-----------------------------------------------------------------------------------------------
-- Client Lua Script for SassyMedicSim
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- SassyMedicSim Module Definition
-----------------------------------------------------------------------------------------------
local SassyMedicSim = {} 

--------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
local tAMPIds =	{
	[710] = "Health Probes",
	[718] = "Empowering Aura",
	[734] = "Armor Pierce I",
	[742] = "PvP Power I",
	[631] = "Victory Spark",
	[639] = "Critical Hit Severity III",
	[711] = "Regenerator",
	[727] = "Power Converter",
	[735] = "Armor Pierce II",
	[743] = "PvP Power II",
	[640] = "Assault Power I",
	[648] = "Danger Zone",
	[672] = "Support Power I",
	[934] = "Quick Dodge",
	[696] = "Amorphous Barrier",
	[712] = "Null Zone",
	[720] = "Cooldowns I",
	[728] = "Scalpel! Forceps!",
	[736] = "Armor Pierce III",
	[744] = "PvP Power III",
	[625] = "Core Damage",
	[641] = "Assault Power II",
	[673] = "Support Power II",
	[681] = "Hypercharge",
	[705] = "CC Resilience I",
	[967] = "Focus Cost III",
	[721] = "Cooldowns II",
	[745] = "Chemical Burn",
	[626] = "Critical Hit I",
	[761] = "PvP Defense I",
	[642] = "Assault Power III",
	[650] = "Meltdown",
	[674] = "Support Power III",
	[682] = "Solid State",
	[706] = "CC Resilience II",
	[714] = "Defense Mechanism",
	[722] = "Cooldowns III",
	[730] = "Surgical",
	[738] = "Lifesteal I",
	[619] = "Strikethrough I",
	[627] = "Critical Hit II",
	[635] = "Stay With Me",
	[643] = "Annihilation",
	[651] = "Focus Recovery I",
	[667] = "Protective Surge",
	[675] = "Rejuvenator",
	[699] = "Shield Reboot",
	[707] = "CC Resilience III",
	[715] = "Shield Protocol",
	[739] = "Lifesteal II",
	[620] = "Strikethrough II",
	[628] = "Critical Hit III",
	[636] = "In Flux",
	[652] = "Focus Recovery II",
	[930] = "Transfusion",
	[708] = "Protection Probes",
	[970] = "Dash Regen III",
	[969] = "Dash Regen II",
	[732] = "Power Cadence",
	[740] = "Lifesteal III",
	[621] = "Strikethrough III",
	[968] = "Dash Regen I",
	[637] = "Critical Hit Severity I",
	[645] = "Entrapment",
	[653] = "Focus Recovery III",
	[966] = "Focus Cost II",
	[965] = "Focus Cost I",
	[677] = "Emergency Extraction",
	[964] = "Maximum Shield Capacity III",
	[932] = "Reboot",
	[962] = "Maximum Shield Capacity I",
	[963] = "Maximum Shield Capacity II",
	[931] = "Emergency",
	[928] = "Recycler",
	[769] = "Debilitative Armor",
	[767] = "Acerbic Injection",
	[622] = "Weakness into Strength",
	[766] = "Concerted Effort",
	[638] = "Critical Hit Severity II",
	[646] = "Renewable Probes",
	[654] = "Running on Empty",
	[765] = "Attrition",
	[763] = "PvP Defense III",
	[678] = "Armor Coating",
	[762] = "PvP Defense II",
	[749] = "Energy Pulse",
	[747] = "Antigen Isolation",
}

local ktConfigAMPs =	{
	"Core Damage",
	"Danger Zone",
	"In Flux",
	"Meltdown",
	"Recycler",
	"Renewable Probes",
	"Scalpel! Forceps!",
	"Surgical",
	"Power Cadence",
	"Critical Hit Severity I",
	"Critical Hit Severity II",
	"Critical Hit Severity III",
}
	
local tSpellIds = {
	[47793] = "Collider",
	[26038] = "Fissure",
	[47675] = "Nullifier",
	[25729] = "Empowering Probes",
	[16322] = "Gamma Rays",
	[47807] = "Dual Shock",
	[47778] = "Discharge",
	[26061] = "Quantum Cascade",
	[27080] = "Annihilation",
	[25666] = "Devastator Probes",
	[25692] = "Atomize",
	[25595] = "Field Probes",

	
--[26786] = "Recharge",
--	[26433] = "Extricate",
--	[26543] = "Paralytic Surge",
--	[25617] = "Antidote",
--	[26529] = "Magnetic Lockdown",
--	[25799] = "Calm",
--	[16336] = "Triage",
--	[22861] = "Restrictor",
--	[25747] = "Urgency",
--	[25613] = "Protection Probes",
--	[16757] = "Shield Surge",
--	[26120] = "Flash",
--	[25530] = "Mending Probes",
--	[25735] = "Dematerialize",
--	[25579] = "Crisis Wave",
--	[25566] = "Barrier",
--	[47784] = "Emission",
--	[24867] = "Rejuvenator",
}

local tRuneSetSpellIds = {
        [25287] = "Assassin",
        [47945] = "Assassin",
        [38690] = "Assassin",
        [34861] = "Assassin",
        [34862] = "Assassin",
        [34563] = "Echo Burst",
        [34564] = "Echo Burst",
        [34565] = "Echo Burst",
        [32567] = "Technophile",
        [32587] = "Technophile",
        [34913] = "Tech Fire Starter",
        [34914] = "Tech Fire Starter",
        [28683] = "Fusion Blast",
        [34974] = "Fusion Blast",
        [34977] = "Fusion Blast",
		[31865] = "Full Charge", 
		[31866] = "Full Charge",
}

local ktCodeEnumSpellResults = {
	["Hit"] = 1,
	["Crit"] = 2,
	["Deflect"] = 3,
}

local ktInstantSpells = { -- Abilities with no Cast / Channel which incur a GCD
	["Collider"] = true,
	["Fissure"] = true,
	["Nullifier"] = true,
	["Annihilation"] = true,
	["Devastator Probes"] = true,
	["Field Probes"] = true,
}

local ktSpellBaseDamage = { -- Base damage per level -- non-level dependent damage dealt with as special cases
	["Collider"] = 10.6,
	["ColliderBonused"] = 13.99,
	["Fissure"] = 10.5,
	["Nullifier"] = 1.46,
	["Gamma Rays"] = 14.43,
	["Dual Shock"] = 25.52,
	["Discharge"] = 4.26,
	["Quantum Cascade"] = 15.48,
	["Annihilation"] = 4.64,
	["Devastator Probes"] = 7.4,
	["Dev Probe Explosion"] = 15.54,
	["Dev Probe Explosion Splash"] = 11.655,
	["Atomize"] = 18.72,
}

local ktSpellAPBonus = {
	["Collider"] = 0.2434,
	["ColliderBonused"] = 0.3211,
	["Fissure"] = 0.2417,
	["Nullifier"] = 0.0335,
	["Gamma Rays"] = 0.3313,
	["Dual Shock"] = 0.5865, -- Uses special handling to scale from SP in damage calcs
	["Discharge"] = 0.0980,
	["Quantum Cascade"] = 0.3555,
	["Annihilation"] = 0.1065,
	["Devastator Probes"] = 0.1696,
	["Dev Probe Explosion"] = 0.35616,
	["Dev Probe Explosion Splash"] = 0.26712,
	["Atomize"] = 0.4303,
	["Meltdown"] = 1.04,
	["Discharge T4"] = 0.2525,
	["Field Probes T8"] = 0.05425,
	["Nullifier T8"] = 0.7812,
	["Fissure T8"] = 0.4540,
	["Atomize T8"] = 0.1498,
}

local ktSpellTierAPBonus = {
	["Collider"] = 0.0253,
	["ColliderBonused"] = 0.0333,
	["Fissure"] = 0.0121,
	["Nullifier"] = 0.0029,
	["Gamma Rays"] = 0.0211,
	["Dual Shock"] = 0.0326, -- Uses special handling to scale from SP in damage calcs
	["Discharge"] = 0.0210,
	["Quantum Cascade"] = 0.0252,
	["Annihilation"] = 0.0069,
	["Devastator Probes"] = 0.0164,
	["Dev Probe Explosion"] = 0.03444,
	["Dev Probe Explosion Splash"] = 0.02583,
	["Atomize"] = 0.0463,
}

local ktSpellTicks = { -- number of ticks, time between ticks, initial delay) -- GR, QC and Discharge dealt with as special cases
	["Collider"] = { 2, 0.5, 0.5 },
	["Nullifier"] = { 24, 0.24, 0.24 },
	["Annihilation"] = { 8, 0.3, 0 },
}

local ktDOTDurations = {
	["Devastator Probes"] = 12,
	["Fire Starter"] = 6,
	["Power Cadence"] = -1,
	["Field Probes T8"] = 10,
	["Atomize T8"] = 6,
}

local ktDOTTickDelays = {
	["Devastator Probes"] = 2,
	["Fire Starter"] = 1,
	["Power Cadence"] = 15,
	["Field Probes T8"] = 1,
	["Atomize T8"] = 2,

}

local ktSpellMaxTargets = {
	["Collider"] = 5,
	["Fissure"] = 5,
	["Gamma Rays"] = 2,
	["Dual Shock"] = 5,
	["Discharge"] = 5,
	["Quantum Cascade"] = 5,
	["Quantum Cascade T4"] = 5,
	["Quantum Cascade T8"] = 5,
	["Annihilation"] = 5,
	["Devastator Probes"] = 5,
	["Atomize"] = 5,
	["Meltdown"] = 5,
	["Discharge T4"] = 5,
	["Dev Probe Explosion"] = 5,
	["Nullifier T8"] = 5,
	["Fissure T8"] = 5,
	["Atomize T8"] = 5,
	-- Unlimited targets maxed at 10
	["Nullifier"] = 10,
	["Fire Starter"] = 10,
	["Field Probes T8"] = 10,

}

local ktProcSpells = {
	["Collider"] = true,
	["Gamma Rays"] = true,
	["Dual Shock"] = true,
	["Discharge"] = true,
	["Quantum Cascade"] = true,
	["Annihilation"] = true,
	["Atomize"] = true,
}

local ktOffGCDSpells = {
	["Dual Shock"] = true,
	["Atomize"] = true,
	["Empowering Probes"] = true,
}

local ktNonTechDamageSpells = {
	["Assassin"] = true,
	["Impact"] = true,
	["Shadow Blast"] = true,
	["Fire Starter"] = true,
}

local ktCannotCrit = {
	["Impact"] = true,
}

local ktInFluxExceptions = { -- Casting these abilities takes priority over maintaining in flux - this is generally because they supply a greater damage boost to spenders than they gain from the in flux buff
	["Fissure"] = true,
	["Field Probes"] = true,
}

local ktSpellSubstitution = {
	["Discharge T4"] = "Discharge",
	["Field Probes T8"] = "Field Probes",
	["Quantum Cascade T8"] = "Quantum Cascade",
	["Dev Probe Explosion Splash"] = "Dev Probe Explosion",
	["Nullifier T8"] = "Nullifier",
	["Fissure T8"] = "Fissure",
	["Atomize T8"] = "Atomize",
}

local ktSpellIconSubstitution = {
	["Meltdown"] = "Energize",
	["Dev Probe Explosion"] = "Devastator Probes",
}

local tExplicitIcons = {
	["Fire Starter"] =  "IconSprites:Icon_SkillFire_UI_srcr_frybrrg",
	["Impact"] = "IconSprites:Icon_SkillStalker_Stance_Defensive",
	["Gadget"] = "Icon_SkillPhysical_UI_wr_fume",
}

local ktStats = {
	{ ["strStat"] = "nAP", ["strName"] = "Assault Power", ["strType"] = "number" },
	{ ["strStat"] = "nSP", ["strName"] = "Support Power", ["strType"] = "number" },
	{ ["strStat"] = "nCritChance", ["strName"] = "Crit Hit Chance", ["strType"] = "percentage" },
	{ ["strStat"] = "nCritSev", ["strName"] = "Crit Severity", ["strType"] = "percentage" },
	{ ["strStat"] = "nStrikethrough", ["strName"] = "Strikethrough", ["strType"] = "percentage" },
	{ ["strStat"] = "nCDR", ["strName"] = "Cooldown Reduction", ["strType"] = "percentage", ["bReversed"] = true },
	{ ["strStat"] = "nArmorPen", ["strName"] = "Armor Pierce", ["strType"] = "percentage" },
}
	
local ktStackingBuffs = {
	["Core Damage"] = 4,
	["Scalpel!"] = 5,
	["Forceps!"] = 5,
	["Rage"] = 3,
	["Unleash Anger"] = 4,
}

local ktEventType = {
	["Cast"] = 1,
	["Damage"] = 2,
	["Actuator"] = 3,
}

local ktSpecialDefaults = {
	["Impact"] = 566,
	["Unleash Anger"] = 19,
	["Rage"] = 11,
}

local tTabs = {
	"Simulate",
	"Visualisation",
	"Configuration",
	"Weight_Calc",
	"Splash",
}

local ktColors = {
	["Cyan"] = CColor.new(0.5882,0.8709,0.9451),
--	["Light"] = CColor.new("ffcdd9dd"),
	["MedLight"] = CColor.new(0.7412,0.8039,0.8235),
	["Medium"] = CColor.new(0.6510,0.7373,0.7647),
	["MedDark"] = CColor.new(0.5216,0.6039,0.6275),
	["Dark"] = CColor.new(0.3529,0.4196,0.4431),
	-- Pixie color tables
	["DPSGraph"] = { a = 1, r = 1, b = 0, g = 0 },
	["ActuatorGraph1"] = { a = 1, r = 0.02, b = 0.06, g = 0.5 },
	["ActuatorGraph2"] = { a = 1, r = 0.03, b = 0.08, g = 0.6 },
	["GraphSelectionLine"] = { a = 0.8, r = 0, b = 1, g = 1 },	
	["Timeline1"] = { a = 1, r = 0.7412, b = 0.8039, g = 0.8235 },
	["Timeline2"] = { a = 1, r = 0.651, b = 0.7373, g = 0.7647 },
	["Timeline3"] = { a = 1, r = 0.5216, b = 0.6039, g = 0.6275 },
}

local ktSimSpeeds = {
	500,
	50,
	5,
}

local knCritRatingPercent = 0.000154
local knStrikethroughRatingPercent = 0.000078

local knInitialGraphScale = 10 -- px per second
local knFrameSample = 10
local knEventsPerFrame = 500
local knDPSVisualisationSecondsPerFrame = 500
local knActuatorVisualisationEventsPerFrame = 500
local knPixiesPerFrame = 500
local knCombatLogPageSize = 100

local knStdDevFactor = 0.33 -- fraction of stddev used for drawing dps histogram of multisims

-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function SassyMedicSim:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
	self.tConfig = {}

    return o
end

function SassyMedicSim:Init()
	local bHasConfigureFunction = true
	local strConfigureButtonText = "SassyMedicSim"
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- SassyMedicSim OnLoad
-----------------------------------------------------------------------------------------------
function SassyMedicSim:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("SassyMedicSim.xml")
	Apollo.LoadSprites("SassyMedicSimSprites.xml", "SassyMedicSimSprites")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- SassyMedicSim OnDocLoaded
-----------------------------------------------------------------------------------------------
function SassyMedicSim:OnDocLoaded()
	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
		Apollo.RegisterTimerHandler("SassyMedicSimInit","CheckPlayerIsMedic",self)
		self:CheckPlayerIsMedic()
	end
end

function SassyMedicSim:CheckPlayerIsMedic()
	if self.wndMain then -- if addon has already initialised then abort
		return
	end
	local unitPlayer = GameLib.GetPlayerUnit()
	if not unitPlayer then
		Apollo.CreateTimer("SassyMedicSimInit",1)
	elseif unitPlayer:GetClassId() == GameLib.CodeEnumClass.Medic then
		self:OnFinalInitialise()
	end
end
	
function SassyMedicSim:OnFinalInitialise()
	self.wndMain = Apollo.LoadForm(self.xmlDoc, "SassyMedicSimForm", nil, self)
	self.wndMain:Show(false,true)
	local tXmlButton = self:GetButtonXml()
	tXmlButton = self:ChangeXmlAttribute(tXmlButton,"RadioGroup","SMSNavBar")
	local xmlButton = XmlDoc.CreateFromTable(tXmlButton)
	local wndNavBar = self.wndMain:FindChild("NavHolder")
	local nNavTotal = #tTabs - 1
	for k,strName in ipairs(tTabs) do
		if strName ~= "Splash" then
			local wndNavButton = Apollo.LoadForm(xmlButton, "InterfaceButton", wndNavBar, self)
			wndNavButton:SetText(string.gsub(strName,"_"," "))
			wndNavButton:SetName("Nav"..strName)
			wndNavButton:AddEventHandler("ButtonCheck","NavButtonCheck",self)
			wndNavButton:SetStyleEx("RadioDisallowNonSelection",true)
			wndNavButton:SetAnchorPoints((k-1)/nNavTotal,0,k/nNavTotal,1)
			wndNavButton:SetAnchorOffsets(4,0,-4,0)
		end
	end		
	self:ActivateNavButton(false,"Visualisation")
	self:ChangeInterfaceTab("Splash")
	
	if self.bSavedSim then
		self:ReinitialiseSavedSim()
	end
	
	if self.tStatWeightSimulations and not (self.bSimRunning and self.strSimType == "StatWeight") then
		self:UpdateStatWeightWindow()
	end
	self.wndMain:FindChild("BreakpointButton"):SetCheck(self.tConfig.bIncludeBreakpoints)
	
	-- Set config defaults if they have not been loaded
	if #self.tConfig == 0 then
		self:SetDefaultConfigBooleans()
	end
	
	if not self.tConfig.tSpellPriorities then
		self.tConfig.tSpellPriorities = self:GetDefaultPriorityList()
	end
	if not self.tConfig.tSpells then
		self.tConfig.tSpells = self:GetPlayerSpells()
	end
	self:UpdateConfigAbilityWindow()	
	
	self:UpdateConfigStatsWindow()
	
	self:UpdateConfigAMPsWindow()
	
	self:UpdateConfigSpecialsWindow()
	
	self:UpdateConfigMiscWindow()
	
	if not self.tConfig.nSimSpeed then
		self.tConfig.nSimSpeed = 1
	end
	self.wndMain:FindChild("SpeedButton"..self.tConfig.nSimSpeed):SetCheck(true)
		
	Apollo.RegisterSlashCommand("sms","OpenInterface",self)
	Apollo.RegisterSlashCommand("sassymedicsim","OpenInterface",self)
end

-----------------------------------------------------------------------------------------------
-- SassyMedicSim Functions
-----------------------------------------------------------------------------------------------

function SassyMedicSim:InitialiseSimulationConfig()
	self.tSimStats = {}
	for k,v in pairs(self.tConfig.tStats) do
		self.tSimStats[k] = v
	end
	self.tSimStats.tAMPs = {}
	for k,v in pairs(self.tConfig.tAMPs) do
		self.tSimStats.tAMPs[k] = v
	end
	self.tSimStats.tSetBonuses = {}
	for k,v in pairs(self.tConfig.tRuneSets) do
		self.tSimStats.tSetBonuses[k] = v
	end
	if self.tSimStats.tSetBonuses["Fusion Blast"] and self.tSimStats.tSetBonuses["Fusion Blast"] >= 8 then
		self.tSimStats.tSetBonuses["Assassin"] = math.max(self.tSimStats.tSetBonuses["Assassin"] or 0,self.tSimStats.tSetBonuses["Fusion Blast"])
	end
	if self.tSimStats.tSetBonuses["Tech Fire Starter"] and self.tSimStats.tSetBonuses["Tech Fire Starter"] >= 8 then
		self.tSimStats.tSetBonuses["Technophile"] = math.max(self.tSimStats.tSetBonuses["Technophile"] or 0,self.tSimStats.tSetBonuses["Tech Fire Starter"])
	end
	self.tSimGadget = {}
	for k,v in pairs(self.tConfig.tGadget) do
		self.tSimGadget[k] = v
	end
	self.tSimSpells = {}
	for strSpell,nId in pairs(self.tConfig.tSpells) do
		self.tSimSpells[strSpell] = GameLib.GetSpell(nId)
	end
	self.tPriorities = {}
	for k,v in ipairs(self.tConfig.tSpellPriorities) do
		self.tPriorities[k] = v
	end
	self.tSimSpecials = {}
	for k,v in pairs(self.tConfig.tSpecials) do
		if v.bActive then
			self.tSimSpecials[k] = v.nAmount
		end
	end
	self.tSimTargetStats = {
		["nDeflectChance"] = self.tConfig.nTargetDeflect / 100,
		["nDeflectCrit"] = self.tConfig.nTargetDeflectCrit / 100,
		["nArmor"] = self.tConfig.nTargetArmor,
		["nResist"] = self.tConfig.nTargetResist,
	}
	self.nTargets = self.tConfig.nTargets
	
	self.nMaxEnergizeActuators = self.tConfig.nMaxEnergizeActuators
	self.nMaxAtomizeActuators = self.tConfig.nMaxAtomizeActuators
	
	self.bInFluxPrioritise = self.tConfig.bInFluxPrioritise
	self.bCoreDamagePrioritise = self.tConfig.bCoreDamagePrioritise
	self.bSaveForEmpProbes = self.tConfig.bSaveForEmpProbes
		
	self.nDelay = self.tConfig.nDelay
	
	self.nMinDevProbTicks = 5
end

function SassyMedicSim:InitialiseSimulation()
	self.tBuffs = {}
	self.tBuffStacks = {}
	self.tSpellCooldowns = {}
	self.tCachedCooldowns = {}
	self.tSpellCharges = {}
	self.tSpellTiers = {}
	self.bDetonationSpec = false
	for k,spl in pairs(self.tSimSpells) do
		local tCharges = spl:GetAbilityCharges()
		if tCharges and tCharges.nChargesMax > 0 then
			self.tSpellCharges[k] = {
				["nCharges"] = tCharges.nChargesMax,
				["nChargesMax"] = tCharges.nChargesMax,
				["nRechargeTime"] = 0,
				["nRechargeTimeMax"] = tCharges.fRechargeTime,
			}
		else
			local nCDTime = spl:GetCooldownTime() * self.tSimStats.nCDR / GameLib.GetPlayerUnit():GetCooldownReductionModifier()
			if nCDTime and nCDTime > 0 then
				self.tSpellCooldowns[k] = 0
				self.tCachedCooldowns[k] = nCDTime
			end
		end
		if k == "Energize" then
			self.tCachedCooldowns[k] = 30		
		end
		if k == "Devastator Probes" and spl:GetTier() > 4 and ( self.tSimSpells["Fissure"] or self.tSimSpells["Collider"] ) then
			self.bDetonationSpec = true
		end
	end	
	self.tCachedCooldowns["Gadget"] = self.tSimGadget.nCD
	
	self.tSimCastEvents = {}
	self.tSimHitEvents = {}
	self.tSimDOTs = {}
	self.tSimDamageEvents = {}
	self.tSimActuatorEvents = {}
	self:AddActuatorEvent(false,4,"Initial Actuators",0)

	self.nTime = 0
	self.nPowerCharges = 0
	self.nGRCastTime = 1.25
	self.nLastQCDeflect = -1
	
	self.bSimRunning = true
	self.bPaused = false
	self.bSimCancelled = false
	
	if self.tSimStats.tAMPs["Power Cadence"] then
		self:AddDOT("Power Cadence",0)
	end
	
	Apollo.RegisterEventHandler("NextFrame","ProcessSimFrame",self)
end

function SassyMedicSim:InitialiseSimpleSim()
	self:ActivateNavButtons(false,{"Simulate"})
	self.strSimType = "Simple"
	self.nSimulationTime = self.tConfig.nSimpleSimTime
	self.tSimpleSimLog = {}
	self.nEventsPerFrame = knEventsPerFrame
	self.tFrameTicks = {}
	self:InitialiseSimulationConfig()
	self:InitialiseSimulation()
	self:StartProgressBar()
end

function SassyMedicSim:InitialiseMultiSim()
	self:ActivateNavButtons(false,{"Simulate"})
	self.strSimType = "Multi"
	self.nSimulationTime = self.tConfig.nMultiSimTime
	self.nMultiSim = 1
	self.nMultiSimIterations = self.tConfig.nMultiSimIterations
	self.tMultiSimDamage = {}
	self.nEventsPerFrame = knEventsPerFrame
	self.tFrameTicks = {}
	self.bSimSetRunning = true
	self:InitialiseSimulationConfig()
	self:InitialiseSimulation()
	self:StartProgressBar()
end

function SassyMedicSim:InitialiseStatWeightSims()
	self:ActivateNavButtons(false,{"Simulate"})
	self.strSimType = "StatWeight"
	self.nEventsPerFrame = knEventsPerFrame
	self.tFrameTicks = {}
	self.tStatWeightSimulations = {
		{ strStat = "Base" },
		{ strStat = "nAP", nAmount = 100, nUnit = 1 },
		{ strStat = "nSP", nAmount = 100, nUnit = 1 },
		{ strStat = "nCritChance", nAmount = 0.02, nUnit = 0.01 },
		{ strStat = "nCritSev", nAmount = 0.04, nUnit = 0.01 },
		{ strStat = "nStrikethrough", nAmount = 0.01, nUnit = 0.01 },
	--	{ strStat = "nCDR", nAmount = 0.05, nUnit = 0.01 },
	--	{ strStat = "nArmorPen", nAmount = 0.02, nUnit = 0.01 },
	}
	self.nCurrentStatWeightSim = 1
	self.bSimSetRunning = true
	self:InitialiseStatWeightSim()
	self:StartProgressBar()
end

function SassyMedicSim:InitialiseStatWeightSim()
	self.nSimulationTime = self.tConfig.nMultiSimTime
	self.nMultiSim = 1
	self.nMultiSimIterations = self.tConfig.nMultiSimIterations
	self.tMultiSimDamage = {}
	self:InitialiseSimulationConfig()
	local tStat = self.tStatWeightSimulations[self.nCurrentStatWeightSim]
	if tStat.strStat ~= "Base" then
		self.tSimStats[tStat.strStat] = self.tSimStats[tStat.strStat] + tStat.nAmount
	end
	self:InitialiseSimulation()
end

function SassyMedicSim:ReinitialiseSavedSim()
	self:ActivateNavButtons(false,{"Simulate"})
	self.nEventsPerFrame = knEventsPerFrame	
	self.tFrameTicks = {}
	self.bSimSetRunning = true
	self:InitialiseSimulationConfig()
	if self.strSimType == "StatWeight" then
		local tStat = self.tStatWeightSimulations[self.nCurrentStatWeightSim]
		if tStat.strStat ~= "Base" then
			self.tSimStats[tStat.strStat] = self.tSimStats[tStat.strStat] + tStat.nAmount
		end
	end
	self:InitialiseSimulation()
	self.bPaused = true
	self:StartProgressBar()
end

function SassyMedicSim:StartProgressBar()
	local wndProgressBar = self.wndMain:FindChild("SimulateTab"):FindChild("ProgressBar")
	local nMax = 0
	if self.strSimType == "Simple" then
		nMax = self.nSimulationTime
	elseif self.strSimType == "Multi" then
		nMax = self.nSimulationTime * self.nMultiSimIterations
	elseif self.strSimType == "StatWeight" then
		nMax = self.nSimulationTime * self.nMultiSimIterations * #self.tStatWeightSimulations
	end
	self.wndMain:FindChild("SimulateTab"):FindChild("PauseButton"):SetCheck(self.bPaused)
	wndProgressBar:SetMax(nMax)
	self:SetProgressBar()
	self:ChangeInterfaceTab("Simulate")
end

function SassyMedicSim:SetProgressBar()
	local nProgress = 0
	if self.strSimType == "Simple" then
		nProgress = self.nTime
	elseif self.strSimType == "Multi" then
		nProgress = self.nTime + self.nSimulationTime * ( self.nMultiSim - 1 )
	elseif self.strSimType == "StatWeight" then
		nProgress = self.nTime + self.nSimulationTime * ( self.nMultiSim - 1 ) + self.nSimulationTime * self.nMultiSimIterations * (self.nCurrentStatWeightSim - 1)
	end
	local wndProgressBar = self.wndMain:FindChild("SimulateTab"):FindChild("ProgressBar")
	wndProgressBar:SetProgress(nProgress)
end

function SassyMedicSim:Paused()
	return self.bPaused
end

function SassyMedicSim:ProcessSimFrame(bSameFrame)
	if self:Paused() then
		self.tFrameTicks = {}
		return
	end
	if self.bSimRunning then
		self:SetProgressBar()
		if not bSameFrame then
			table.insert(self.tFrameTicks,Apollo.GetTickCount())
			if #self.tFrameTicks > knFrameSample then
				table.remove(self.tFrameTicks,1)
				local nDiff = 0
				for nTickKey,nTicks in ipairs(self.tFrameTicks) do
					if nTickKey  > 1 then
						nDiff = nDiff + ( nTicks - self.tFrameTicks[nTickKey-1] )
					end
				end
				nDiff = nDiff / #self.tFrameTicks -- get average frame interval
				local nEventStep = 50
				if nDiff > ktSimSpeeds[self.tConfig.nSimSpeed] then
					self.nEventsPerFrame = math.max(self.nEventsPerFrame - nEventStep,nEventStep)
				else
					self.nEventsPerFrame = math.min(self.nEventsPerFrame + nEventStep, self.nSimulationTime * 2)
				end
			end
			self.nEventsProcessed = 0
		end
		self:ProcessSimulation()
	else
		Apollo.RemoveEventHandler("NextFrame",self)
		if not self.bSimCancelled then
			self:EndSimulation()
		end
	end
end

function SassyMedicSim:ProcessSimulation()
	if not self.bSimRunning then
		return
	end
	while self.nTime < self.nSimulationTime and self.nEventsProcessed < self.nEventsPerFrame do
		local bSpellFound
		local tSimEvent = {}
		for _,strSpell in ipairs(self.tPriorities) do
			if self.tSimSpells[strSpell] and self:GetSpellValidity(strSpell) then
				bSpellFound = true
				
				if strSpell == "Energize" and self.tSimGadget.bEnabled and not self:IsSpellOnCooldown("Gadget", self.nTime) then
					self:SetBuffTime("Gadget", self.nTime, self.tSimGadget.nDuration)
					self:ProcessSpellCooldowns("Gadget", self.nTime)
					local tGadgetEvent = {
						["strSpellName"] = "Gadget",
						["nTime"] = self.nTime,
						["nDuration"] = 0,
						["nActuators"] = self.nActuators,
					}
					table.insert(self.tSimCastEvents,tGadgetEvent)
					if self.strSimType == "Simple" then
						table.insert(self.tSimpleSimLog,{nType = ktEventType["Cast"], nKey = #self.tSimCastEvents})
					end
				end
				
				tSimEvent = {
					["strSpellName"] = strSpell,
					["nTime"] = self.nTime,
					["nDuration"] = self:GetCastDuration(strSpell),
					["nActuators"] = self.nActuators,
				}
				table.insert(self.tSimCastEvents,tSimEvent)
				if self.strSimType == "Simple" then
					table.insert(self.tSimpleSimLog,{nType = ktEventType["Cast"], nKey = #self.tSimCastEvents})
				end
				self:QueueHitEvents(strSpell)
				self:ProcessHitEvents()
				local tSquishes = self:GetValidSquishes(tSimEvent) -- Add Atomize, Dual Shock and/or Emp Probes if they can be fit in this ability
				for _,tSquish in pairs(tSquishes) do
					table.insert(self.tSimCastEvents,tSquish)
					if self.strSimType == "Simple" then
						table.insert(self.tSimpleSimLog,{nType = ktEventType["Cast"], nKey = #self.tSimCastEvents})
					end
					self:QueueHitEvents(tSquish.strSpellName)
				end
				break
			end
		end
		if not bSpellFound then
			local nSoonestCD = self.nSimulationTime
			for k,v in pairs(self.tSpellCooldowns) do
				if v < nSoonestCD and v > self.nTime then
					nSoonestCD = v
				end	
			end
			self.nTime = nSoonestCD
			--self.strSimFailed = "No valid spell found."
			--self.bSimRunning = false
			--return
		else
			self.nTime = math.min(self.nTime + tSimEvent.nDuration + self.nDelay, self.nSimulationTime)
		end
		self:ProcessHitEvents()
		self.nEventsProcessed = self.nEventsProcessed + 1
	end
	if self.nTime >= self.nSimulationTime then
		self:ProcessDOTs(self.nSimulationTime)
		self.bSimRunning = false
	end
end

function SassyMedicSim:CreateResultsEntry(strSpellName)
	self.tSimResults[strSpellName] = {
		["Casts"] = 0,
		["Hits"] = 0,
		["HitDamage"] = 0,
		["Crits"] = 0,
		["CritDamage"] = 0,
		["Deflects"] = 0,
		["Damage"] = 0,
	}
end

function SassyMedicSim:EndSimulation()
	if self.strSimFailed then
		Print("SassyMedicSim: Simulation failed. " .. self.strSimFailed)
		self.strSimFailed = false
		self:ActivateNavButtons(true,{"Visualisation"})
		self:ChangeInterfaceTab("Splash")
		return
	end
	self.tSimResults = {}
	local nMultiSimDamage = 0
	if self.strSimType == "Simple" then
		for _,tDamageEvent in pairs(self.tSimDamageEvents) do
			if not self.tSimResults[tDamageEvent.strSpellName] then
				self:CreateResultsEntry(tDamageEvent.strSpellName)
			end
			if tDamageEvent.nHitType == ktCodeEnumSpellResults.Crit then
				self.tSimResults[tDamageEvent.strSpellName]["Crits"] = self.tSimResults[tDamageEvent.strSpellName]["Crits"] + 1
				self.tSimResults[tDamageEvent.strSpellName]["CritDamage"] = self.tSimResults[tDamageEvent.strSpellName]["CritDamage"] + tDamageEvent.nDamage
			elseif tDamageEvent.nHitType == ktCodeEnumSpellResults.Deflect then
				self.tSimResults[tDamageEvent.strSpellName]["Deflects"] = self.tSimResults[tDamageEvent.strSpellName]["Deflects"] + 1
			else
				self.tSimResults[tDamageEvent.strSpellName]["Hits"] = self.tSimResults[tDamageEvent.strSpellName]["Hits"] + 1
				self.tSimResults[tDamageEvent.strSpellName]["HitDamage"] = self.tSimResults[tDamageEvent.strSpellName]["HitDamage"] + tDamageEvent.nDamage
			end
			self.tSimResults[tDamageEvent.strSpellName]["Damage"] = self.tSimResults[tDamageEvent.strSpellName]["Damage"] + tDamageEvent.nDamage
		end
		for _,tCastEvent in pairs(self.tSimCastEvents) do
			if not self.tSimResults[tCastEvent.strSpellName] then
				self:CreateResultsEntry(tCastEvent.strSpellName)
			end
			self.tSimResults[tCastEvent.strSpellName].Casts =	self.tSimResults[tCastEvent.strSpellName].Casts + 1
		end
	else
		for _,tDamageEvent in pairs(self.tSimDamageEvents) do
			nMultiSimDamage = nMultiSimDamage + tDamageEvent.nDamage
		end
	end
	if self.strSimType == "Multi" then
		table.insert( self.tMultiSimDamage, nMultiSimDamage/self.nSimulationTime )
		if self.nMultiSim >= self.nMultiSimIterations then
			table.sort(self.tMultiSimDamage)
			local nTotal,nEntries = 0,0
			
			for k,nDPS in ipairs(self.tMultiSimDamage) do
				nTotal = nTotal + nDPS
				nEntries = nEntries + 1
			end
			
			local nMean = nTotal / nEntries
			local tVariances = {}
			for k,nDPS in pairs(self.tMultiSimDamage) do
				table.insert(tVariances,(nDPS - nMean)^2)
			end
			
			local nStdDev = 0
			for _,v in pairs(tVariances) do
				nStdDev = nStdDev + v
			end
			nStdDev = math.sqrt( nStdDev / nEntries )

			local tDistribution = {}
			local tDistributionEntries = {}
			local nSampleWidth = nStdDev * knStdDevFactor
			for k,nDPS in ipairs(self.tMultiSimDamage) do
				local nRoundDPS = nDPS - (nDPS - (nMean % nSampleWidth ) + nSampleWidth / 2 ) % nSampleWidth + nSampleWidth / 2
				if tDistributionEntries[nRoundDPS] then
					tDistribution[tDistributionEntries[nRoundDPS] ] = tDistribution[tDistributionEntries[nRoundDPS] ] + 1
				else
					table.insert(tDistribution,1)
					tDistributionEntries[nRoundDPS] = #tDistribution	
				end
			end
			local tFinalDistribution = {}
			local nMaxProb = 0
			local nMaxProbDPS
			for nDPS,nKey in pairs(tDistributionEntries) do
				table.insert(tFinalDistribution, {["nDPS"] = nDPS, ["nProb"] = tDistribution[nKey] / #self.tMultiSimDamage})
				if tDistribution[nKey] / #self.tMultiSimDamage > nMaxProb then
					nMaxProb = tDistribution[nKey] / #self.tMultiSimDamage
					nMaxProbDPS = nDPS
				end
			end
			table.sort(tFinalDistribution, function (a,b) return a.nDPS < b.nDPS end)
			local nMedian = self.tMultiSimDamage[math.floor(#self.tMultiSimDamage / 2)]
			self.bSimSetRunning = false
			self:DrawMultiSimHisto(tFinalDistribution,nMaxProb,self:Round(nMean,2,true),self:Round(nMedian,2,true),self:Round(self.tMultiSimDamage[1],2,true),self:Round(self.tMultiSimDamage[#self.tMultiSimDamage],2,true),self:Round(nStdDev,2,true))
			self:ActivateNavButtons(true,{"Visualisation"})
			self:ChangeInterfaceTab("Weight_Calc")
		else
			self.nMultiSim = self.nMultiSim + 1
			self:InitialiseSimulation()
			self:ProcessSimFrame(true)
		end
	elseif self.strSimType == "StatWeight" then
		table.insert( self.tMultiSimDamage, nMultiSimDamage/self.nSimulationTime )
		if self.nMultiSim >= self.nMultiSimIterations then
			local nTotal,nEntries = 0,0
			for k,nDPS in ipairs(self.tMultiSimDamage) do
				nTotal = nTotal + nDPS
				nEntries = nEntries + 1
			end
			self.tStatWeightSimulations[self.nCurrentStatWeightSim].nDPS = nTotal / nEntries
			if self.nCurrentStatWeightSim >= #self.tStatWeightSimulations then
				local nBase,nNorm
				for k,tStat in ipairs(self.tStatWeightSimulations) do
					if tStat.strStat == "Base" then
						nBase = tStat.nDPS
						tStat.nAEP = 0
					else
						tStat.nDiff = tStat.nDPS - nBase
						if tStat.strStat == "nAP" then
							tStat.nAEP = 1
							nNorm = tStat.nDiff / tStat.nAmount
						else
							tStat.nAEP = tStat.nUnit * ( tStat.nDiff / tStat.nAmount ) / nNorm
						end
					end
					self.tStatWeightSimulations[k] = tStat
				end
				self:UpdateStatWeightWindow()
				self.bSimSetRunning = false
				self:ActivateNavButtons(true,{"Visualisation"})
				self:ChangeInterfaceTab("Weight_Calc")
			else
				self.nCurrentStatWeightSim = self.nCurrentStatWeightSim + 1
				self:InitialiseStatWeightSim()
				self:ProcessSimFrame(true)
			end
		else
			self.nMultiSim = self.nMultiSim + 1
			self:InitialiseSimulation()
			self:ProcessSimFrame(true)
		end		
	elseif self.strSimType == "Simple" then
		self:ActivateNavButtons(false,{"Visualisation"})
		self:ChangeInterfaceTab("Visualisation")
		self:UpdateVisualisation()
	end
end

function SassyMedicSim:CancelSimulation()
	self.bSimRunning = false
	self.bSimSetRunning = false
	self.bSimCancelled = true
	self:ActivateNavButtons(true,{"Visualisation"})
	if self.strSimType == "Simple" then
		self:ChangeInterfaceTab("Splash")
	else
		if self.strSimType == "StatWeight" then
			self.tStatWeightSimulations = nil
		end
		self:ChangeInterfaceTab("Weight_Calc")
	end
end

function SassyMedicSim:GetLocalSpellName(strSpellName)
	local strLocalSpellName
	if self.tSimSpells[strSpellName] then
		strLocalSpellName = self.tSimSpells[strSpellName]:GetName()
	else
		strLocalSpellName = strSpellName
	end
	return strLocalSpellName
end

function SassyMedicSim:SetSpellIcon(wndIcon,strSpellName)
	if not wndIcon then
		return
	end
	local strIcon
	if self.tSimSpells and self.tSimSpells[strSpellName] then
		strIcon = self.tSimSpells[strSpellName]:GetIcon()
	elseif ktSpellIconSubstitution[strSpellName] and self.tSimSpells and self.tSimSpells[ktSpellIconSubstitution[strSpellName]] then
		strIcon = self.tSimSpells[ktSpellIconSubstitution[strSpellName]]:GetIcon()
	elseif strSpellName == "Energize" then
		strIcon = GameLib.GetCurrentClassInnateAbilitySpell():GetIcon()
	elseif tExplicitIcons[strSpellName] then
		strIcon = tExplicitIcons[strSpellName]
	else
		local spl = self:GetSpell(strSpellName)
		if spl then
			strIcon = spl:GetIcon()
		end
	end

	if strIcon then
		wndIcon:SetSprite(strIcon)
		wndIcon:SetBGColor(CColor.new(1,1,1))
	end
end

function SassyMedicSim:GetSpell(strSpellName,nTier)
	if strSpellName == "Energize" then
		return GameLib.GetCurrentClassInnateAbilitySpell()
	end
	local nId
	for k,v in pairs(tSpellIds) do
		if v == strSpellName then
			nId = k
			break
		end
	end
	nTier = nTier or 1
	local tSpellTags = { Spell.CodeEnumSpellTag.Assault, Spell.CodeEnumSpellTag.Support, Spell.CodeEnumSpellTag.Utility, Spell.CodeEnumSpellTag.Misc }
	for _,nTag in ipairs(tSpellTags) do
		for _,tAbility in pairs(AbilityBook.GetAbilitiesList(nTag)) do
			if tAbility.nId == nId then
				return tAbility.tTiers[nTier].splObject
			end
		end
	end
end

function SassyMedicSim:AddActuatorEvent(bModify,nAmount,strSource,nTime)
	if bModify then
		self.nActuators = self.nActuators + nAmount
	else
		self.nActuators = nAmount
	end
	if self.nActuators > 4 then
		self.nActuators = 4
	end
	local tEvent = {
		["bModify"] = bModify,
		["nAmount"] = nAmount,
		["strSource"] = strSource,
		["nTime"] = nTime,
		["nActuators"] = self.nActuators,
	}
	table.insert(self.tSimActuatorEvents,tEvent)
	if self.strSimType == "Simple" then
		table.insert(self.tSimpleSimLog,{nType = ktEventType["Actuator"], nKey = #self.tSimActuatorEvents})
	end
end

function SassyMedicSim:AddDOT(strDOT, nTime)
	tDOT = {}
	tDOT.nLastTickTime = nTime
	local nDuration = ktDOTDurations[strDOT]
	if nDuration == -1 then
		nDuration = self.nSimulationTime + 1
	end 
	tDOT.nEndTime = nTime + nDuration
	tDOT.nTickDelay = ktDOTTickDelays[strDOT]
	tDOT.nAP = self:GetCurrentAP(nTime)
	if strDOT == "Field Probes T8" then
		tDOT.nAP = self:GetCurrentAP(nTime) + self:GetCurrentSP(nTime)
	end
	tDOT.nDamageMod = self:GetDamageMod(nTime)
	self.tSimDOTs[strDOT] = tDOT
end

function SassyMedicSim:ProcessDOTs(nTime)
	local tDOTTicks = {}
	for strDOT, tDOT in pairs(self.tSimDOTs) do
		if tDOT.nLastTickTime < tDOT.nEndTime then
			local nProcessTicks = math.floor((nTime - tDOT.nLastTickTime)/tDOT.nTickDelay)
			if nProcessTicks > 0 then
				for i = 1,nProcessTicks do
					local nTickTime = tDOT.nTickDelay + tDOT.nLastTickTime
					if nTickTime <= tDOT.nEndTime then
						tDOTTick = {
							["strSpellName"] = strDOT,
							["nTime"] = nTickTime,
							["nAP"] = tDOT.nAP,
							["nDamageMod"] = tDOT.nDamageMod, 
						}
						tDOT.nLastTickTime = nTickTime
						local bTickAdded
						if #tDOTTicks > 0 then
							for nKey = #tDOTTicks, 1, -1 do
								if tDOTTicks[nKey].nTime <= tDOTTick.nTime then
									table.insert(tDOTTicks,nKey+1,tDOTTick)
									bTickAdded = true
									break
								end
							end
						end
						if not bTickAdded then
							table.insert(tDOTTicks,tDOTTick)
						end
					end
				end
				self.tSimDOTs[strDOT].nLastTickTime = tDOT.nLastTickTime
			end
		end
	end
	for k,tDOTTick in ipairs(tDOTTicks) do
		self:ProcessHitEvent( tDOTTick )
	end
end

function SassyMedicSim:StopDOT(strDOT, nTime)
	if self.tSimDOTs[strDOT] then
		self.tSimDOTs[strDOT].nEndTime = nTime - 0.01
	end
end

function SassyMedicSim:ProcessHitEvents()
	local tRemoveHitKeys = {}
	self.bPurgeQCHitEvents = false
	for nHitKey, tHitEvent in ipairs(self.tSimHitEvents) do
		if tHitEvent.nTime <= self.nTime and not self.bPurgeQCHitEvents then
			self:ProcessDOTs(tHitEvent.nTime)
			self:ProcessHitEvent(tHitEvent)
			table.insert( tRemoveHitKeys, 1, nHitKey )
		elseif self.bPurgeQCHitEvents then
			if tHitEvent.strSpellName == "Quantum Cascade" or tHitEvent.strSpellName == "Quantum Cascade T4" or tHitEvent.strSpellName == "Quantum Cascade T8" then
				table.insert( tRemoveHitKeys, 1, nHitKey )
			end
		else
			break
		end
	end
	for _,nHitKey in ipairs(tRemoveHitKeys) do
		table.remove( self.tSimHitEvents, nHitKey )
	end
end

function SassyMedicSim:ProcessHitEvent(tHitEvent)
	if tHitEvent.nTime > self.nSimulationTime then
		return
	end
	if tHitEvent.strSpellName == "Empowering Probes" then
		local nEmpProbeTime = 10
		if self:GetSpellTier("Empowering Probes") > 8 then
			nEmpProbeTime = 13
		end
		self:SetBuffTime("Empowering Probes", tHitEvent.nTime, nEmpProbeTime )
		return
	end
	if tHitEvent.strSpellName == "Field Probes" then
		self:SetBuffTime("Field Probes", tHitEvent.nTime, 10 )
		if self:GetSpellTier("Field Probes") > 8 then
			self:AddDOT("Field Probes T8", tHitEvent.nTime)
		end
		return
	end
	if tHitEvent.strSpellName == "Power Cadence" then
		self:AddActuatorEvent(true, 1, "Power Cadence", tHitEvent.nTime)
		return
	end
	if tHitEvent.strSpellName == "Energize" then
		self:SetBuffTime("Energize", tHitEvent.nTime, 8 )
		self:AddActuatorEvent(false,4,"Energize", tHitEvent.nTime)
		local nFullCharge = self.tSimStats.tSetBonuses["Full Charge"]
		if nFullCharge then
			if nFullCharge >= 6 then
				self:SetBuffTime("Full Charge", tHitEvent.nTime, 5)
			end
		end
		if self.tSimStats.tAMPs["Meltdown"] then
			tHitEvent.strSpellName = "Meltdown"
		else
			return
		end
	end
	if tHitEvent.strSpellName == "Atomize" or tHitEvent.strSpellName == "Dual Shock" then
		self:RemoveBuff("Clear!", tHitEvent.nTime)
	end
	-- Attack Table Processing
	local tGRDeflects = { 1, 1, 1 }
	local nGRCrits = 0
	local nQCCrits = 0
	local bDeflect = true -- only true if all hits are deflected
	local nTargets = math.min(self.nTargets, ktSpellMaxTargets[tHitEvent.strSpellName] or 1 )
	for nTarget = 1,nTargets do
		local tHits = {}
		if tHitEvent.strSpellName == "Gamma Rays" then
			for i = 1,3 do
				local nHitType = ktCodeEnumSpellResults.Hit
				if self:GetDeflect(tHitEvent.nTime) then
					nHitType = ktCodeEnumSpellResults.Deflect
				else
					if self:GetCritical(tHitEvent.nTime) then
						nHitType = ktCodeEnumSpellResults.Crit
						nGRCrits = nGRCrits + 1
					end
					bDeflect = false
					tGRDeflects[i] = 0
				end
				table.insert(tHits,nHitType)
			end
		else
			local nHitType = ktCodeEnumSpellResults.Hit
			if (tHitEvent.nForceDeflect or 0) > 0 or self:GetDeflect(tHitEvent.nTime) then
				nHitType = ktCodeEnumSpellResults.Deflect
			else
				if (not ktCannotCrit[tHitEvent.strSpellName]) and self:GetCritical(tHitEvent.nTime) then
					nHitType = ktCodeEnumSpellResults.Crit
				end
				bDeflect = false
			end
			table.insert(tHits,nHitType)
			if tHitEvent.strSpellName == "Quantum Cascade" or tHitEvent.strSpellName == "Quantum Cascade T4" or tHitEvent.strSpellName == "Quantum Cascade T8" then
				for _,nHitType in pairs(tHits) do
					if nHitType ~= ktCodeEnumSpellResults.Deflect then
						if nHitType == ktCodeEnumSpellResults.Crit then
							nQCCrits = nQCCrits + 1
						end
					end
				end
			end
		end
		-- Attack Effects	
		for nHitKey,nHitType in pairs(tHits) do
			-- Damage
			local nDamage
			if nHitType == ktCodeEnumSpellResults.Deflect then
				nDamage = 0
			else
				-- AP and DamageMod are only passed for DOTs where these variables are set at cast time
				nDamage = self:GetSpellDamage(tHitEvent.strSpellName, tHitEvent.nTime, nHitType == ktCodeEnumSpellResults.Crit, tHitEvent.nAP, tHitEvent.nDamageMod )
			end
			
			local tDamageEvent = {
				["strSpellName"] = tHitEvent.strSpellName,
				["nTime"] = tHitEvent.nTime,
				["nDamage"] = nDamage,
				["nHitType"] = nHitType,
			}
			if ktSpellSubstitution[tDamageEvent.strSpellName] then
				tDamageEvent.strSpellName = ktSpellSubstitution[tDamageEvent.strSpellName]
			end
			table.insert(self.tSimDamageEvents,tDamageEvent)
			if self.strSimType == "Simple" then
				table.insert(self.tSimpleSimLog,{nType = ktEventType["Damage"], nKey =  #self.tSimDamageEvents})
			end
			
			-- Procs per hit
			if ktProcSpells[tHitEvent.strSpellName] then
				
				if nHitType == ktCodeEnumSpellResults.Crit then
					self:SetBuffTime("Clear!", tHitEvent.nTime , 5 )
					
					local nEchoBurst = self.tSimStats.tSetBonuses["Echo Burst"]
					if nEchoBurst and nEchoBurst >= 6 then
						self:ProcessHitEvent( { ["strSpellName"] = "Echo Burst" , ["nTime"] = tHitEvent.nTime } )
					end
					
					local nAssassin = self.tSimStats.tSetBonuses["Assassin"]
					if nAssassin and nAssassin >= 4 and tHitEvent.nTime > self.nSimulationTime * 0.7 and math.random() <= 0.25 then
						self:ProcessHitEvent( { ["strSpellName"] = "Assassin" , ["nTime"] = tHitEvent.nTime } )
					end
					
					local nFusionBlast = self.tSimStats.tSetBonuses["Fusion Blast"]
					if nFusionBlast and nFusionBlast >= 20 and math.random() <= 0.05 then
						for i = 1,math.min(self.nTargets,4) do
							self:ProcessHitEvent( { ["strSpellName"] = "Shadow Blast" , ["nTime"] = tHitEvent.nTime } )
						end
					end
					
					local nTechFireStarter = self.tSimStats.tSetBonuses["Tech Fire Starter"]
					if nTechFireStarter and nTechFireStarter >= 20 and self:GetBuffTime("Fire Starter") < tHitEvent.nTime then
						self:AddDOT("Fire Starter", tHitEvent.nTime)
						self:SetBuffTime( "Fire Starter", tHitEvent.nTime, 10 )
					end
					
					if self.tSimSpecials["Impact"] and self:GetBuffTime("Impact") <= tHitEvent.nTime then
						self:SetBuffTime( "Impact", tHitEvent.nTime, 2.5 )
						self:ProcessHitEvent( { ["strSpellName"] = "Impact" , ["nTime"] = tHitEvent.nTime } )
					end
					
					if self.tSimSpecials["Rage"] then
						self:SetBuffTime( "Rage", tHitEvent.nTime, 6 )
					end
				end
				
				if self.tSimSpecials["Unleash Anger"] then
					if nHitType == ktCodeEnumSpellResults.Crit then
						self:RemoveBuff("Unleash Anger", tHitEvent.nTime)
					elseif nHitType == ktCodeEnumSpellResults.Hit then
						self:SetBuffTime("Unleash Anger", tHitEvent.nTime, 5)
					end
				end
				
				local nTechnophile = self.tSimStats.tSetBonuses["Technophile"]
				if nTechnophile and math.random() <= 0.1 then
					self:SetBuffTime("Technophile", tHitEvent.nTime , 5 )
				end
				
			end
			
			if tHitEvent.strSpellName == "Fissure" then
				self:SetBuffTime("Fissure", tHitEvent.nTime, 12)
			end
			
			if tHitEvent.strSpellName == "Dev Probe Explosion" and self:GetSpellTier("Devastator Probes") > 8 then
				local nSplashTargets = math.min(nTargets-1,2)
				if nSplashTargets > 0 then
					for i = 1,nSplashTargets do
						self:ProcessHitEvent( { ["strSpellName"] = "Dev Probe Explosion Splash" , ["nTime"] = tHitEvent.nTime, ["nAP"] = tHitEvent.nAP, ["nDamageMod"] = tHitEvent.nDamageMod } )
					end
				end
			end
		end
	end
	
	-- Procs per attack
	if ktProcSpells[tHitEvent.strSpellName] then
		if self.tSimStats.tAMPs["Scalpel! Forceps!"] and not bDeflect then -- SF buff stacking mechanic is dealt with in :SetBuffTime()
			if tHitEvent.strSpellName == "Dual Shock" then
				self:SetBuffTime("Scalpel!",tHitEvent.nTime,6)
			else
				self:SetBuffTime("Forceps!",tHitEvent.nTime,6)
			end
		end
	end
	
	if self.bDetonationSpec and (tHitEvent.strSpellName == "Fissure" or tHitEvent.strSpellName == "Collider") then
		if self.tSimDOTs["Devastator Probes"] and self.tSimDOTs["Devastator Probes"].nEndTime >= tHitEvent.nTime then
			self:ProcessHitEvent( { ["strSpellName"] = "Dev Probe Explosion" , ["nTime"] = tHitEvent.nTime, ["nAP"] = self.tSimDOTs["Devastator Probes"].nAP, ["nDamageMod"] = self.tSimDOTs["Devastator Probes"].nDamageMod } )
			if self.tSimStats.tAMPs["Renewable Probes"] and math.random() <= 0.25 then
				self:AddDOT( "Devastator Probes", tHitEvent.nTime)
			else
				self:StopDOT("Devastator Probes", tHitEvent.nTime)
			end
		end
	end
	
	if tHitEvent.strSpellName == "Fissure" and self.nActuators == 4 and self:GetSpellTier("Fissure") > 4 then
		self:SetBuffTime("Fissure T4", tHitEvent.nTime, self.nSimulationTime)
	end
	
	if tHitEvent.strSpellName == "Discharge" and self.tSimSpells["Annihilation"] and self.tSpellCooldowns["Annihilation"] and self:GetSpellTier("Annihilation") > 8 then
		self.tSpellCooldowns["Annihilation"] = self.tSpellCooldowns["Annihilation"] - 1.25
	end
	
	if tHitEvent.strSpellName == "Atomize" and self:GetSpellTier("Atomize") > 8 then
		self:AddDOT("Atomize T8", tHitEvent.nTime)
	end
	
		-- Actuator Costs/Returns
	if tHitEvent.strSpellName == "Gamma Rays" then
		if self:GetSpellTier("Gamma Rays") > 4 then
			self.nGRCastTime = self.nGRCastTime - 0.45
			if self.nGRCastTime < 0.35 then
				self.nGRCastTime = 1.25
			end
		end
		local nGRDeflects = 0
		for _,n in pairs(tGRDeflects) do
			nGRDeflects = nGRDeflects + n
		end
		self:AddActuatorEvent(true, -2, "Gamma Rays", tHitEvent.nTime)
		if self:GetSpellTier("Gamma Rays") > 8 and math.random() <= ( 3 - nGRDeflects ) / 3 then
			self:AddActuatorEvent(true, 1, "Gamma Rays T8", tHitEvent.nTime)
		end
		if self.tSimStats.tAMPs["Recycler"] then
			while nGRCrits > 0 do
				if math.random() <= 0.3 then
					self:AddActuatorEvent(true, 1, "Recycler", tHitEvent.nTime)
				end
				nGRCrits = nGRCrits - 1
			end
		end
		if self:GetBuffTime("Fissure T4") >= tHitEvent.nTime then
			self:AddActuatorEvent(true, 1, "Fissure T4", tHitEvent.nTime)
			self:RemoveBuff("Fissure T4", tHitEvent.nTime )
		end
		if self.tSimStats.tAMPs["Core Damage"] then
			self:SetBuffTime("Core Damage",tHitEvent.nTime,5)
		end
	elseif tHitEvent.strSpellName == "Quantum Cascade" or tHitEvent.strSpellName == "Quantum Cascade T4" or tHitEvent.strSpellName == "Quantum Cascade T8" then
		if tHitEvent.strSpellName == "Quantum Cascade" then
			self:AddActuatorEvent(true, -1, "Quantum Cascade", tHitEvent.nTime)
			if self.tSimStats.tAMPs["Core Damage"] then
				self:SetBuffTime("Core Damage",tHitEvent.nTime,5)
			end
			if self:GetBuffTime("Fissure T4") >= tHitEvent.nTime then
				self:AddActuatorEvent(true, 1, "Fissure T4", tHitEvent.nTime)
				self:RemoveBuff("Fissure T4", tHitEvent.nTime )
			end
			if self.nActuators < 1 then
				local nQCCastKey
				for i = #self.tSimCastEvents,1,-1 do
					if self.tSimCastEvents[i].strSpellName == "Quantum Cascade" then
						nQCCastKey = i
						break
					end
				end
				self.tSimCastEvents[nQCCastKey].nDuration = math.max(1,self.tSimCastEvents[nQCCastKey].nTime - tHitEvent.nTime)
				self.nTime = self.tSimCastEvents[nQCCastKey].nTime + self.tSimCastEvents[nQCCastKey].nDuration
				self.bPurgeQCHitEvents = true	
			end
		end
		if bDeflect then
			self.nLastQCDeflect = tHitEvent.nTime
		end
		if self.tSimStats.tAMPs["Recycler"] then
			while nQCCrits > 0 do
				if math.random() <= 0.25 then
					self:AddActuatorEvent(true, 1, "Recycler", tHitEvent.nTime)
				end
				nQCCrits = nQCCrits - 1
			end
		end
		if tHitEvent.strSpellName == "Quantum Cascade T8" and self:GetBuffTime("Quantum Cascade T8") < tHitEvent.nTime and self.nLastQCDeflect < tHitEvent.nTime - 1.5 then
			self:AddActuatorEvent(true, 2, "Quantum Cascade T8", tHitEvent.nTime)
			self:SetBuffTime("Quantum Cascade T8",tHitEvent.nTime,10)
		end
	elseif tHitEvent.strSpellName == "Discharge" then
		local nChargeStacks = 1
		if self:GetSpellTier("Discharge") > 8 then
			nChargeStacks = 2	
		end
		self.nPowerCharges = self.nPowerCharges + nChargeStacks
		if self.nPowerCharges > 2 then
			self.nPowerCharges = self.nPowerCharges - 3
			self:AddActuatorEvent(true, 1, "Discharge", tHitEvent.nTime)
		end
	elseif tHitEvent.strSpellName == "Atomize" then
		self:AddActuatorEvent(true, 1, "Atomize", tHitEvent.nTime)
	elseif tHitEvent.strSpellName == "Dual Shock" and self:GetSpellTier("Dual Shock") > 4 then
		if math.random() <= 0.25 then
			self:AddActuatorEvent(true, 1, "Dual Shock T4", tHitEvent.nTime)
		end
	elseif tHitEvent.strSpellName == "Collider" and self:GetSpellTier("Collider") > 8 and tHitEvent.nTime > self.nSimulationTime * 0.7 and (self.nLastColliderT8 or -1) < tHitEvent.nTime - 0.6 then
		self:AddActuatorEvent(true, 1, "Collider T8", tHitEvent.nTime)
		self.nLastColliderT8 = tHitEvent.nTime
	end
end

function SassyMedicSim:GetDeflect(nTime)
	local nStrikethrough = self.tSimStats.nStrikethrough
	local nRating = knStrikethroughRatingPercent
	if self:GetBuffTime("Empowering Probes") >= nTime then
		if self:GetSpellTier("Empowering Probes") > 4 then
			nStrikethrough = nStrikethrough + 0.03
		end
	end
	if self:GetBuffTime("Gadget") >= nTime then
		nStrikethrough = nStrikethrough + self.tSimGadget.nStrikethrough * nRating
	end
	if math.random() > self.tSimTargetStats.nDeflectChance - nStrikethrough then
		return false
	else
		return true
	end
end

function SassyMedicSim:GetCritical(nTime)
	local nCritChance = self.tSimStats.nCritChance
	local nRating = knCritRatingPercent
	if self:GetBuffTime("Empowering Probes") >= nTime then
		if self:GetSpellTier("Empowering Probes") > 4 then
			nCritChance = nCritChance + 0.03
		end
	end
	if self:GetBuffTime("Gadget") >= nTime then
		nCritChance = nCritChance + self.tSimGadget.nCritChance * nRating
	end
	if self:GetBuffTime("Unleash Anger") >= nTime then
		nCritChance = nCritChance + self.tSimSpecials["Unleash Anger"] * self.tBuffStacks["Unleash Anger"] * nRating
	end
	if math.random() > nCritChance - self.tSimTargetStats.nDeflectCrit then
		return false
	else
		return true
	end
end

function SassyMedicSim:GetCurrentAP(nTime)
	local nAP = self.tSimStats.nAP
	if self.tSimStats.tAMPs["In Flux"] and self.nActuators < 4 and self.nActuators > 1 then
		nAP = nAP * 1.12
	end
	if self.tSimStats.tAMPs["Danger Zone"] and nTime % 15 <= 8 then -- Danger Zone implemented as simple modulus of fight time
		nAP = nAP * 1.17
	end
	if self:GetBuffTime("Energize") >= nTime then
		nAP = nAP * 1.17	
	end
	if self:GetBuffTime("Scalpel!") >= nTime then
		nAP = nAP * ( 1 + 0.03 * self.tBuffStacks["Scalpel!"] )
	end
	
	-- TO DO - Surgical
	
	if self:GetBuffTime("Rage") >= nTime then
		nAP = nAP + self.tSimSpecials["Rage"] * self.tBuffStacks["Rage"]
	end
	if self:GetBuffTime("Gadget") >= nTime then
		nAP = nAP + self.tSimGadget.nAP
	end
		
	if self:GetBuffTime("Full Charge") >= nTime then
		local nFullCharge = self.tSimStats.tSetBonuses["Full Charge"]
		if nFullCharge then
			local nFullChargeAP = 0
			if nFullCharge >= 15 then
				nFullChargeAP = 276
			elseif nFullCharge >= 11 then
				nFullChargeAP = 228
			elseif nFullCharge >= 6 then
				nFullChargeAP = 168
			end
			nAP = nAP + nFullChargeAP
		end
	end
	return nAP
end

function SassyMedicSim:GetCurrentSP(nTime)
	local nSP = self.tSimStats.nSP
	
	if self:GetBuffTime("Energize") >= nTime then
		nSP = nSP * 1.17
	end
	if self:GetBuffTime("Forceps!") >= nTime then
		nSP = nSP * ( 1 + 0.03 * self.tBuffStacks["Forceps!"] )
	end
	if self:GetBuffTime("Rage") >= nTime then
		nSP = nSP + self.tSimSpecials["Rage"] * self.tBuffStacks["Rage"]
	end
	if self:GetBuffTime("Full Charge") >= nTime then
		local nFullCharge = self.tSimStats.tSetBonuses["Full Charge"]
		if nFullCharge then
			local nFullChargeAP = 0
			if nFullCharge >= 15 then
				nFullChargeAP = 276
			elseif nFullCharge >= 11 then
				nFullChargeAP = 228
			elseif nFullCharge >= 6 then
				nFullChargeAP = 168
			end
			nSP = nSP + nFullChargeAP
		end
	end
	return nSP
end

function SassyMedicSim:GetDamageMod(nTime)
	local nDamageMod = 1
	if self:GetBuffTime("Core Damage") >= nTime then
		nDamageMod = nDamageMod * ( 1 + self.tBuffStacks["Core Damage"] * 0.015 )
	end
	if self:GetBuffTime("Empowering Probes") >= nTime then
		nDamageMod = nDamageMod * ( 1.1 + ( self:GetSpellTier("Empowering Probes") - 1 ) * 0.00625 )
	end
	if self.tSimStats.tAMPs["Surgical"] and self:GetBuffTime("Field Probes") >= nTime then
		nDamageMod = nDamageMod * 1.09
	end
	local nTechnophile = self.tSimStats.tSetBonuses["Technophile"]
	if nTechnophile and not ktNonTechDamageSpells[strSpell] then
		local nTechnophileBonus = 0
		if nTechnophile >= 12 then
			nTechnophileBonus = 0.02
		elseif nTechnophile >= 8 then
			nTechnophileBonus = 0.015
		elseif nTechnophile >= 4 then
			nTechnophileBonus = 0.01
		end
		nDamageMod = nDamageMod * ( 1 + nTechnophileBonus )
	end
	return nDamageMod
end

function SassyMedicSim:GetSpellDamage(strSpell,nTime,bCrit,nFixedAP,nFixedDamageMod)
	if strSpell == "Quantum Cascade T8" then
		strSpell = "Quantum Cascade"
	end
	if strSpell == "Collider" then
		local nColliderBonusThreshold = 0.3
		if self:GetSpellTier("Collider") > 4 then
			nColliderBonusThreshold = 0.7
		end
		if nTime >= self.nSimulationTime * ( 1 - nColliderBonusThreshold ) then
			strSpell = "ColliderBonused"
		end
	end
	
	local nBaseDamage = ktSpellBaseDamage[strSpell] or 0
	local nAPBonus = ktSpellAPBonus[strSpell] or 0
	local nAPTierBonus = ktSpellTierAPBonus[strSpell] or 0
	local nAP = 0
	local nPlayerLevel = 50
	
	-- AP Modifiers
	if nAPBonus + nAPTierBonus > 0 then		
		-- Use SP instead of AP for Dual Shock		
		if strSpell == "Dual Shock" then
			nAP = self:GetCurrentSP(nTime)
		else	
			nAP = nFixedAP or self:GetCurrentAP(nTime)
		end
	end
	
	if strSpell == "Echo Burst" then
		local nRuneSet = self.tSimStats.tSetBonuses["Echo Burst"]
		if nRuneSet >= 15 then
			nBaseDamage = 79 / nPlayerLevel
		elseif nRuneSet >= 11 then
			nBaseDamage = 66 / nPlayerLevel
		elseif nRuneSet >= 6 then
			nBaseDamage = 48 / nPlayerLevel
		end
	elseif strSpell == "Assassin" then
		local nRuneSet = self.tSimStats.tSetBonuses["Assassin"]
		if nRuneSet >= 12 then
			nBaseDamage = 40 / nPlayerLevel
		elseif nRuneSet >= 8 then
			nBaseDamage = 30 / nPlayerLevel
		elseif nRuneSet >= 4 then
			nBaseDamage = 20 / nPlayerLevel
		end
	elseif strSpell == "Shadow Blast" then
		nBaseDamage = 1207 / nPlayerLevel
	elseif strSpell == "Fire Starter" then
		nBaseDamage = 145 / nPlayerLevel
	elseif strSpell == "Impact" then
		nBaseDamage = self.tSimSpecials["Impact"] / nPlayerLevel
		nFixedDamageMod = 1
	end
							
	local nDamageMod = nFixedDamageMod or self:GetDamageMod(nTime)	
		
	if bCrit then
		local nCritSev = self.tSimStats.nCritSev
		if self:GetBuffTime("Gadget") >= nTime and self.tSimGadget.nCritSev > 0 then
			nCritSev = nCritSev + self.tSimGadget.nCritSev * self:GetCritSeverityRatingValue()
		end
		nDamageMod = nDamageMod * nCritSev
	end	

	local nTier = 0
	if self.tSimSpells[strSpell] then
		nTier = self:GetSpellTier(strSpell) - 1
	end
	local nDamage = ( nBaseDamage * nPlayerLevel + nAPBonus * nAP + nAPTierBonus * nTier * nAP ) * nDamageMod
	
	-- Mitigation
	local nArmor = self.tSimTargetStats.nArmor
	local nArmorPen = self.tSimStats.nArmorPen
	
	if strSpell == "Atomize" and self:GetSpellTier("Atomize") > 4 then
		nArmorPen = nArmorPen + 0.15
	end
	
	nArmor = nArmor * ( 1 - nArmorPen )
		
	local nResist = self.tSimTargetStats.nResist
	local nResistPen = 0 -- Percentage reduction
	local nResistReduction = 0 -- Flat reduction
	
	if self:GetBuffTime("Technophile") >= nTime and nTechnophile and not ktNonTechDamageSpells[strSpell] then
		if nTechnophile >= 12 then
			nResistReduction = nResistReduction + 480
		elseif nTechnophile >= 8 then
			nResistReduction = nResistReduction + 360
		elseif nTechnophile >= 4 then
			nResistReduction = nResistReduction + 240
		end
	end

	if self:GetBuffTime("Fissure") >= nTime and not ktNonTechDamageSpells[strSpell] then
		nResistPen = nResistPen + 0.17
	end
	
	nResist = math.max(nResist - nResistReduction , 0)
	
	local nMitigation = math.max( ( ( nArmor + nResist ) / ( nArmor + nResist + nPlayerLevel * 250 + 200 ) ) * ( 1 - nResistPen ) , 0 )
	
	nDamage = nDamage * ( 1 - nMitigation )
	
	return nDamage
end

function SassyMedicSim:QueueHitEvents(strSpell)
	tSpellTicks = ktSpellTicks[strSpell]
	if tSpellTicks then
		for i = 0,(tSpellTicks[1] - 1) do
			self:QueueHitEvent( strSpell, self.nTime + tSpellTicks[2] * i + tSpellTicks[3] )
		end
	elseif strSpell == "Fissure" then
		local bDeflected
		for i = 1,3 do -- We preroll deflect for Fissure to accurately simulate T8 bonus
			local nHitTime = self.nTime + 0.25 * i
			local bDeflect = self:GetDeflect(nHitTime)
			if bDeflect then
				bDeflected = true
			end
			self:QueueHitEvent( "Fissure", nHitTime, true, bDeflect)
		end
		if self:GetSpellTier("Fissure") > 8 and not bDeflected then
			self:QueueHitEvent("Fissure T8", self.nTime + 0.75)
		end
	elseif strSpell == "Devastator Probes" then
		self:AddDOT("Devastator Probes",self.nTime)
	elseif strSpell == "Quantum Cascade" then
		local nQCTier = self:GetSpellTier("Quantum Cascade")
		local nQCTicks = 3
		if nQCTier > 4 then
			nQCTicks = 4
		end
		for i = 1,nQCTicks do
			local strQCName = "Quantum Cascade"
			if i == 4 then
				if nQCTier > 8 then
					strQCName = "Quantum Cascade T8"
				else
					strQCName = "Quantum Cascade T4"
				end
			end
			self:QueueHitEvent(strQCName, self.nTime + 0.5 * i )
		end
	elseif strSpell == "Discharge" then
		local nDischargeTier = self:GetSpellTier("Discharge")
		local bDeflected
		for i = 1,3 do -- We preroll deflect for Discharge to accurately simulate T4 bonus
			local bDeflect = self:GetDeflect(self.nTime + 0.416 * i)
			if bDeflect then
				bDeflected = true
			end
			self:QueueHitEvent("Discharge", self.nTime + 0.416 * i, true, bDeflect)
		end
		if not bDeflected then
			self:QueueHitEvent("Discharge T4", self.nTime + 0.416 * 3)
		end
	elseif strSpell == "Gamma Rays" then
		self:QueueHitEvent(strSpell,self.nGRCastTime + self.nTime)
	else
		self:QueueHitEvent(strSpell,self.nTime)
	end
	if strSpell == "Nullifier" and self:GetSpellTier("Nullifier") > 8 then
		self:QueueHitEvent("Nullifier T8", self.nTime)
	end
	self:ProcessSpellCooldowns(strSpell, self.nTime)
end

function SassyMedicSim:ProcessSpellCooldowns(strSpell, nTime)
	if self.tCachedCooldowns[strSpell] then
		local nCDTime = self.tCachedCooldowns[strSpell]
		self.tSpellCooldowns[strSpell] = nTime + nCDTime
	elseif self.tSpellCharges[strSpell] then
		if self.tSpellCharges[strSpell].nRechargeTime <= nTime then
			self.tSpellCharges[strSpell].nCharges = self.tSpellCharges[strSpell].nChargesMax
			self.tSpellCharges[strSpell].nRechargeTime = nTime + self.tSpellCharges[strSpell].nRechargeTimeMax
		end
		self.tSpellCharges[strSpell].nCharges = self.tSpellCharges[strSpell].nCharges - 1	
	end
end

function SassyMedicSim:IsSpellOnCooldown(strSpell,nTime)
	if self.tSpellCooldowns[strSpell] and self.tSpellCooldowns[strSpell] > nTime then
		return true
	end
	if self.tSpellCharges[strSpell] and self.tSpellCharges[strSpell].nCharges < 1 and self.tSpellCharges[strSpell].nRechargeTime > nTime then
		return true
	end
	return false
end

function SassyMedicSim:GetNextAvailableTime(strSpell)
	if self.tSpellCooldowns[strSpell] then
		return self.tSpellCooldowns[strSpell]
	end
	if self.tSpellCharges[strSpell] then
		if self.tSpellCharges[strSpell].nCharges > 0 then
			return 0
		else
			return self.tSpellCharges[strSpell].nRechargeTime
		end
	end
	return 0
end

function SassyMedicSim:GetSpellTier(strSpell)
	if not self.tSpellTiers[strSpell] then
		self.tSpellTiers[strSpell] = self.tSimSpells[strSpell]:GetTier()
	end
	return self.tSpellTiers[strSpell]
end

function SassyMedicSim:QueueHitEvent( strSpell , nTime , bForceDeflect, bDeflected)
	local tHitEvent = {
		["strSpellName"] = strSpell,
		["nTime"] = nTime,
	}
	if bForceDeflect then
		if bDeflected then
			tHitEvent.nForceDeflect = 1
		else
			tHitEvent.nForceDeflect = 0
		end
	end
	local bEventAdded
	if #self.tSimHitEvents > 0 then
		for nHitKey = #self.tSimHitEvents, 1, -1 do
			if self.tSimHitEvents[nHitKey].nTime <= tHitEvent.nTime then
				table.insert(self.tSimHitEvents,nHitKey+1,tHitEvent)
				bEventAdded = true
				break
			end
		end
	end
	if not bEventAdded then
		table.insert(self.tSimHitEvents,1,tHitEvent)
	end
end

function SassyMedicSim:GetValidSquishes(tSimEvent)
	local tSquishes = {}
	local bClearBuffUsed
	for _,strSpell in ipairs(self.tPriorities) do
		if ktOffGCDSpells[strSpell] and self.tSimSpells[strSpell] then
			if tSimEvent.nDuration >= 1 then
				if strSpell == "Empowering Probes" and ktInstantSpells[tSimEvent.strSpellName] and self.tSpellCooldowns["Empowering Probes"] <= self.nTime + tSimEvent.nDuration - 1 then
					local tSquish = {
						["strSpellName"] = "Empowering Probes",
						["nTime"] = math.max(self.nTime,self.tSpellCooldowns["Empowering Probes"]),
						["nDuration"] = 1,
						["nActuators"] = self.nActuators,
					}
					table.insert(tSquishes,tSquish)
				end
			end
			if tSimEvent.nDuration >= 0.5 then
				local nActuators = self.nActuators
				if tSimEvent.strSpellName == "Discharge" then
					nActuators = nActuators + 2
				end
				if strSpell == "Atomize" and self.tSpellCooldowns["Atomize"] <= self.nTime + tSimEvent.nDuration - 0.5 and nActuators <= self.nMaxAtomizeActuators and not bClearBuffUsed then
					local nAtomizeTime = math.max(self.nTime,self.tSpellCooldowns["Atomize"])
					if nAtomizeTime < self:GetBuffTime("Clear!") then
						local tSquish = {
							["strSpellName"] = "Atomize",
							["nTime"] = math.max(self.nTime,self.tSpellCooldowns["Atomize"]),
							["nDuration"] = 0.5,
							["nActuators"] = self.nActuators,
						}
						table.insert(tSquishes,tSquish)
						bClearBuffUsed = true
					end
				elseif strSpell == "Dual Shock" and self.tSpellCooldowns["Dual Shock"] <= self.nTime + tSimEvent.nDuration - 0.5 and not bClearBuffUsed then
					local nAtomizeTime = math.max(self.nTime,self.tSpellCooldowns["Dual Shock"])
					if nAtomizeTime < self:GetBuffTime("Clear!") then
						local tSquish = {
							["strSpellName"] = "Dual Shock",
							["nTime"] = math.max(self.nTime,self.tSpellCooldowns["Dual Shock"]),
							["nDuration"] = 0.5,
							["nActuators"] = self.nActuators,
						}
						table.insert(tSquishes,tSquish)
						bClearBuffUsed = true
					end		
				end
			end
		end
	end
	return tSquishes
end

function SassyMedicSim:GetCastDuration(strSpell)
	if strSpell == "Gamma Rays" then
		return self.nGRCastTime
	end
	if strSpell == "Energize" then
		return 0
	end
	local spl = self.tSimSpells[strSpell]
	local nChannelTime = 0
	if spl:GetCastMethod() == Spell.CodeEnumCastMethod.Channeled or Spell.CodeEnumCastMethod.ChanneledField then
		local nMaxtime,nInitialDelay = spl:GetChannelData()
		if not nMaxtime then
			nMaxtime = 0
		end
		if not nInitialDelay then
			nInitialDelay = 0
		end
		nChannelTime = nMaxtime + nInitialDelay
	end
	local nGCDTime = spl:GetGCDTime()
	local nCastTime = spl:GetCastTime()
	return math.max( nGCDTime, nCastTime + nChannelTime )
end

function SassyMedicSim:GetSpellValidity(strSpell)
	-- Check cooldowns
	if self:IsSpellOnCooldown(strSpell,self.nTime) then
		return false
	end

	-- Check that the spell meets Hard Actuator requirements
	if strSpell == "Gamma Rays" and self.nActuators < 2 then
		return false
	end
	if strSpell == "Quantum Cascade" and self.nActuators < 1 then
		return false
	end
	if strSpell == "Energize" and self.nActuators > self.nMaxEnergizeActuators then
		return false
	end

	-- Prioritise influx uptime - Don't cast non-actuator abilities if at 0 or 4 actuators
	if self.bInFluxPrioritise and self.tSimStats.tAMPs["In Flux"] and not ktInFluxExceptions[strSpell] then
		if self.nActuators == 0 and strSpell ~= "Discharge" and self.tSimSpells["Discharge"] then
			return false
		end
		if self.nActuators == 4 and strSpell ~= "Gamma Rays" and strSpell ~= "Quantum Cascade" and (self.tSimSpells["Gamma Rays"] or self.tSimSpells["Quantum Cascade"]) then
			return false
		end
	end

	-- Prioritise core damage - Don't cast other abilities if it would cause CD buff to drop
	if self.bCoreDamagePrioritise and self.tSimStats.tAMPs["Core Damage"] and strSpell ~= "Gamma Rays" and strSpell ~= "Quantum Cascade" and strSpell ~= "Discharge" and (self.tSimSpells["Gamma Rays"] or self.tSimSpells["Quantum Cascade"]) then
		local nCoreDamageTime = self:GetBuffTime("Core Damage") - self.nTime
		if nCoreDamageTime > 0 then
			local nTimeForCoreDamageUpkeep
			if self.tSimSpells["Quantum Cascade"] then
				if self.nActuators < 1 then
					nTimeForCoreDamageUpkeep = 0.5 + 1.25
				else
					nTimeForCoreDamageUpkeep = 0.5
				end
			else
				if self.nActuators < 2 then
					nTimeForCoreDamageUpkeep = self.nGRCastTime + 1.25
				else
					nTimeForCoreDamageUpkeep = self.nGRCastTime
				end				
			end
			if nCoreDamageTime - nTimeForCoreDamageUpkeep > 0 and nCoreDamageTime - nTimeForCoreDamageUpkeep < self:GetCastDuration(strSpell) then
				return false
			end
		end
	end
	
	-- Only cast QC with less than 3 actuators if required to upkeep Core Damage
	if strSpell == "Quantum Cascade" and self.nActuators < 3 then
		if self.bCoreDamagePrioritise and self.tSimStats.tAMPs["Core Damage"] then
			local nCoreDamageTime = self:GetBuffTime("Core Damage") - self.nTime
			if nCoreDamageTime > 0.5 + 1.25 or nCoreDamageTime < 0.5 then
				return false
			end
		else
			return false
		end
	end
	
	-- Do not cast Instants if it will reduce Empowering Probes uptime
	if self.bSaveForEmpProbes and ktInstantSpells[strSpell] and self.tSimSpells["Empowering Probes"] then
		if self:IsSpellOnCooldown("Empowering Probes", self.nTime) then
			local nSoonestInstant
			for strInstantSpell in pairs(ktInstantSpells) do
				if strInstantSpell ~= strSpell and self.tSimSpells[strInstantSpell] then
					if (not nSoonestInstant) or nSoonestInstant > self:GetNextAvailableTime(strInstantSpell) then
						nSoonestInstant = self:GetNextAvailableTime(strInstantSpell)
					end
				end
			end
			if self.tSpellCharges[strSpell] then -- for instants with charges see if another charge of this spell will be available
				if self.tSpellCharges[strSpell].nCharges > 1 then
					nSoonestInstant = 0
				elseif (not nSoonestInstant) or nSoonestInstant > self.tSpellCharges[strSpell].nRechargeTime then
					nSoonestInstant = self.tSpellCharges[strSpell].nRechargeTime
				end
			end
			if (not nSoonestInstant) or nSoonestInstant > self.tSpellCooldowns["Empowering Probes"] then
				return false
			end
		end
	end
	
	-- TO DO - Only cast low priority instants if Emp Probes is available
	

	-- Dev Probes logic - do not cast if detonation spells will be unavailable or if debuff is already present
	if strSpell == "Devastator Probes" then
		if self.tSimDOTs["Devastator Probes"] and self.tSimDOTs["Devastator Probes"].nEndTime >= self.nTime then
			return false
		end
		if self.bDetonationSpec then
			local nSoonestDetonate
			if self.tSimSpells["Collider"] then
				nSoonestDetonate = self:GetNextAvailableTime("Collider")
			end
			if self.tSimSpells["Fissure"] then
				if (not nSoonestDetonate) or nSoonestDetonate > self:GetNextAvailableTime("Fissure") then
					nSoonestDetonate = self:GetNextAvailableTime("Fissure")
				end
			end
			if nSoonestDetonate and nSoonestDetonate > self.nTime + 12 then
				return false
			end
		end
	end
	
	-- Fissure / Collider logic - do not detonate devprobes until min ticks
	if bDetonationSpec and (strSpell == "Collider" or strSpell == "Fissure") and self.tSimDOTs["Devastator Probes"].nEndTime >= self.nTime then
		local nTicksElapsed = 0
		if self.tSimDOTs["Devastator Probes"] and self.tSimDOTs["Devastator Probes"].nEndTime >= self.nTime then
			nTicksElapsed = 6 - math.floor( ( self.tSimDOTs["Devastator Probes"].nEndTime - self.nTime ) / 2 )
		end
		if nTicksElapsed < self.nMinDevProbTicks then
			return false
		end
	end
	
	-- Collider logic - only cast below threshold or if needed for detonate spec
	if strSpell == "Collider" and (not bDetonationSpec) then
		local nColliderBonusThreshold = 0.3
		if self:GetSpellTier("Collider") > 4 then
			nColliderBonusThreshold = 0.7
		end
		if self.nTime < self.nSimulationTime *(1 - nColliderBonusThreshold) then
			return false
		end
	end
	
	return true
end

function SassyMedicSim:GetBuffTime(strBuff)
	if not self.tBuffs[strBuff] then
		return -1
	end
	return self.tBuffs[strBuff]
end

function SassyMedicSim:SetBuffTime(strBuff,nTime,nDuration)
	if ktStackingBuffs[strBuff] then
		if not self.tBuffStacks[strBuff] then
			self.tBuffStacks[strBuff] = 0
			self.tBuffs[strBuff] = 0
		end
		if self.tBuffs[strBuff] >= nTime then
			if strBuff == "Scalpel!" or strBuff == "Forceps!" then -- Special handling for Scalpel Forceps behaviour
				local strThisBuff = strBuff
				local strThatBuff
				if strBuff == "Scalpel!" then strThatBuff = "Forceps!" else strThatBuff = "Scalpel!" end
				if self.tBuffStacks[strThatBuff] and self.tBuffStacks[strThatBuff] + self.tBuffStacks[strThisBuff] + 1 >= 5 then
					if self.tBuffStacks[strThisBuff] > self.tBuffStacks[strThatBuff] then
						self.tBuffStacks[strThisBuff] = self.tBuffStacks[strThisBuff] - 1
					else
						self.tBuffStacks[strThatBuff] = self.tBuffStacks[strThatBuff] - 1
					end
				end				
			end
			self.tBuffStacks[strBuff] = math.min( ktStackingBuffs[strBuff], self.tBuffStacks[strBuff] + 1 )
		else
			self.tBuffStacks[strBuff] = 1
		end
	end
	self.tBuffs[strBuff] = math.max( nTime + nDuration, self.tBuffs[strBuff] or 0 )
end

function SassyMedicSim:RemoveBuff(strBuff,nTime)
	self.tBuffs[strBuff] = nTime
	if self.tBuffStacks[strBuff] then
		self.tBuffStacks[strBuff] = 0
	end
end

function SassyMedicSim:Round(n,nDecimals,bFormat)
	nDecimals = nDecimals or 0
	n = math.floor( n * (10^nDecimals) + 0.5) / (10^nDecimals)
	local nFormatted = n
	if bFormat then
		nFormatted = math.floor(n)
		nRem = string.sub(tostring(n - nFormatted),3,nDecimals + 2)
		nFormatted = nFormatted .. "." .. nRem .. string.rep("0", nDecimals - string.len(nRem) )
	end
	return nFormatted
end
--[[
function SassyMedicSim:GetPlayerStats()
	local unitPlayer = GameLib.GetPlayerUnit()
	local tPlayerStats = {}
	tPlayerStats.nAP = unitPlayer:GetAssaultPower()
	tPlayerStats.nSP = unitPlayer:GetSupportPower()
	tPlayerStats.nCritChance = unitPlayer:GetCritChance()
	tPlayerStats.nCritSev = unitPlayer:GetCritSeverity()
	tPlayerStats.nStrikethrough = unitPlayer:GetStrikethroughChance()
	tPlayerStats.nCDR = unitPlayer:GetCooldownReductionModifier()
	tPlayerStats.nArmorPen = unitPlayer:GetIgnoreArmorBase()
	tPlayerStats.tAMPs = {}
	for _,tAugment in pairs(AbilityBook.GetEldanAugmentationData(AbilityBook.GetCurrentSpec()).tAugments) do
		if tAMPIds[tAugment.nId] and tAugment.eEldanAvailability == AbilityBook.CodeEnumEldanAvailability.Activated then
			tPlayerStats.tAMPs[tAMPIds[tAugment.nId] ] = true
		end
	end
	tPlayerStats.tSetBonuses = self:GetPlayerRuneSets()
	return tPlayerStats
end
]]

function SassyMedicSim:SyncAMPs()
	self.tConfig.tAMPs = {}
	for _,tAugment in pairs(AbilityBook.GetEldanAugmentationData(AbilityBook.GetCurrentSpec()).tAugments) do
		if tAMPIds[tAugment.nId] and tAugment.eEldanAvailability == AbilityBook.CodeEnumEldanAvailability.Activated then
			self.tConfig.tAMPs[tAMPIds[tAugment.nId]] = true
		end
	end
end

function SassyMedicSim:SyncStats()
	for k,tStat in ipairs(ktStats) do
		self.tConfig.tStats[tStat.strStat] = self:GetPlayerStat(tStat.strStat)
	end
end

function SassyMedicSim:SyncRuneSets()
	local unitPlayer = GameLib.GetPlayerUnit()
	local tItems = CraftingLib.GetValidGlyphableItems(true)
	self.tConfig.tRuneSets = {}
	for _, item in pairs(tItems) do
		local tItemBonuses = item:GetSetBonuses()
		for _, tBonuses in pairs(tItemBonuses) do
			if tBonuses.arBonuses and #tBonuses.arBonuses > 0 then
				local tBonus = tBonuses.arBonuses[#tBonuses.arBonuses]
				local nBonusBaseId = tBonus.splBonus:GetBaseSpellId()
				local strBonusName = tRuneSetSpellIds[nBonusBaseId]
				if strBonusName and not self.tConfig.tRuneSets[strBonusName] then
					self.tConfig.tRuneSets[strBonusName] = tBonuses.nPower
				end
			end
		end
	end
end

function SassyMedicSim:GetPlayerStat(strStat)
	local unitPlayer = GameLib.GetPlayerUnit()
	local nAmount
	if strStat == "nAP" then
		nAmount = unitPlayer:GetAssaultPower()
	elseif strStat == "nSP" then
		nAmount = unitPlayer:GetSupportPower()
	elseif strStat == "nCritChance" then 
		nAmount = unitPlayer:GetCritChance()
	elseif strStat == "nCritSev" then 
		nAmount = unitPlayer:GetCritSeverity()
	elseif strStat == "nStrikethrough" then 
		nAmount = unitPlayer:GetStrikethroughChance()
	elseif strStat == "nCDR" then 
		nAmount = unitPlayer:GetCooldownReductionModifier()
	elseif strStat == "nArmorPen" then 
		nAmount = unitPlayer:GetIgnoreArmorBase()
	end
	return nAmount
end

function SassyMedicSim:GetPlayerSpells()
	local tPlayerSpells = {}
	tPlayerSpells["Energize"] = GameLib.GetCurrentClassInnateAbilitySpell():GetId()
	local tSpellTags = { Spell.CodeEnumSpellTag.Assault, Spell.CodeEnumSpellTag.Support, Spell.CodeEnumSpellTag.Utility }
	for _,nTag in pairs(tSpellTags) do
		for _,tAbility in pairs(AbilityBook.GetAbilitiesList(nTag)) do
			for _,nId in pairs(ActionSetLib.GetCurrentActionSet()) do
				if tAbility.nId == nId and tSpellIds[nId] then
					tPlayerSpells[tSpellIds[nId]] = tAbility.tTiers[tAbility.nCurrentTier].splObject:GetId()
				end
			end
		end
	end
	return tPlayerSpells
end

function SassyMedicSim:GetDefaultPriorityList()
	local tPriorities = {
		"Energize",
		"Field Probes",
		"Fissure",
		"Collider",
		"Nullifier",
		"Devastator Probes",
		"Annihilation",
		"Gamma Rays",
		"Quantum Cascade",
		"Discharge",
		"Empowering Probes",
		"Atomize",
		"Dual Shock",
	}
	return tPriorities
end

-----------------------------------------------------------------------------------------------
-- SassyMedicSimForm Functions
-----------------------------------------------------------------------------------------------

function SassyMedicSim:OpenInterface()
    if not self.wndMain then
		return
	else
		self.wndMain:Show(not self.wndMain:IsVisible(),false)
	end
end

function SassyMedicSim:CloseInterface()
	self.wndMain:Show(false,false)
end

function SassyMedicSim:OnConfigure()
	self:OpenInterface()
end

function SassyMedicSim:ChangeInterfaceTab(strNewTab)
	for _,strTabName in pairs(tTabs) do
		local bShow
		if strTabName == strNewTab then
			bShow = true
		end
		local wndTab = self.wndMain:FindChild(strTabName.."Tab")
		if wndTab then
			wndTab:Show(bShow,true)
		end
		local wndNavButton = self.wndMain:FindChild("Nav"..strTabName)
		if wndNavButton then
			if wndNavButton:IsChecked() ~= bShow then
				wndNavButton:SetCheck(bShow)
			end
		end
	end
end

function SassyMedicSim:NavButtonCheck( wndHandler, wndControl, eMouseButton )
	local strName = wndControl:GetName()
	self:ChangeInterfaceTab(string.gsub(strName,"Nav","",1))
	if strName == "NavSimulate" then
		self:InitialiseSimpleSim()
	end
end

function SassyMedicSim:ActivateNavButtons(bActivate,tExceptions)
	local tKeyExceptions = {}
	if tExceptions then
		for _,v in pairs(tExceptions) do
			tKeyExceptions[v] = true
		end
	end
	for _,strTab in pairs(tTabs) do
		local wndNavButton = self.wndMain:FindChild("Nav"..strTab)
		local bActivateThis = bActivate
		if tKeyExceptions[strTab] then
			bActivateThis = not bActivate
		end
		if wndNavButton then
			wndNavButton:Enable(bActivateThis)
		end
	end	
end

function SassyMedicSim:ActivateNavButton(bActivate,strTab)
	local wndNavButton = self.wndMain:FindChild("Nav"..strTab)
	wndNavButton:Enable(bActivate)
end

function SassyMedicSim:UpdateStatWeightWindow()
	local wndWeights = self.wndMain:FindChild("StatWeightsBG"):FindChild("List")
	wndWeights:DestroyChildren()
	local tNameSub = {
		["nAP"] = "Assault Power",
		["nSP"] = "Support Power",
		["nCritChance"] = "Critical Hit Chance",
		["nCritSev"] = "Critical Hit Severity",
		["nStrikethrough"] = "Strikethrough Chance",
	}
	local nCritRatingDiff,nCritRatingAEP,nCritSevRatingDiff,nCritSevRatingAEP,nStrikeDiff,nStrikeAEP,nAPDiff
	for k,tStat in ipairs(self.tStatWeightSimulations) do
		if tStat.strStat ~= "Base" and tStat.nDiff and tStat.nAmount and tStat.nUnit and tStat.nAEP then
			self:AddStatWeightRow(wndWeights, tNameSub[tStat.strStat], tStat.nUnit, (tStat.nDiff / tStat.nAmount) * tStat.nUnit, tStat.nAEP)
			if tStat.strStat == "nAP" then
				nAPDiff = tStat.nDiff / tStat.nAmount
			elseif tStat.strStat == "nCritChance" then
				local nRating = knCritRatingPercent
				nCritRatingDiff =  (tStat.nDiff / tStat.nAmount) * tStat.nUnit * nRating * 100
				nCritRatingAEP = tStat.nAEP * nRating * 100
				self:AddStatWeightRow(wndWeights, "Critical Hit Rating", 1, nCritRatingDiff, nCritRatingAEP )
			elseif tStat.strStat =="nCritSev" then
				if not self.tStatWeightSimulations.nCritSeverityRatingValue then
					self.tStatWeightSimulations.nCritSeverityRatingValue = self:GetCritSeverityRatingValue()
				end
				local nRating = self.tStatWeightSimulations.nCritSeverityRatingValue
				nCritSevRatingDiff =  (tStat.nDiff / tStat.nAmount) * tStat.nUnit * nRating * 100
				nCritSevRatingAEP = tStat.nAEP * nRating * 100
				self:AddStatWeightRow(wndWeights, "Critical Severity Rating", 1, nCritSevRatingDiff, nCritSevRatingAEP)
			elseif tStat.strStat == "nStrikethrough" then
				local nRating = knStrikethroughRatingPercent
				nStrikeDiff =  (tStat.nDiff / tStat.nAmount) * tStat.nUnit * nRating * 100
				nStrikeAEP = tStat.nAEP * nRating * 100
				self:AddStatWeightRow(wndWeights, "Strikethrough Rating", 1, nStrikeDiff, nStrikeAEP)
			end
		end
	end
	local nTechAP = 0.5
	local nMoxieCrit = 0.5
	local nMoxieCritSev = 0.5
	local nBrutCritSev = 0.5
	local nBrutStrike = 0.5
	if self.tConfig.bIncludeBreakpoints then -- Assumes Tech R5, Moxie/Brut R4
		nTechAP = 0.72
		nMoxieCrit = 0.75
		nMoxieCritSev = 0.67
		nBrutCritSev = 0.67
		nBrutStrike = 0.75
	end
	if nCritSevRatingDiff and nStrikeDiff and nCritRatingDiff and nCritSevRatingAEP and nStrikeAEP and nCritRatingAEP then
		self:AddStatWeightRow(wndWeights, "Brutality", 1, nCritSevRatingDiff * nBrutCritSev + nStrikeDiff * nBrutStrike, nCritSevRatingAEP * nBrutCritSev + nStrikeAEP * nBrutStrike )
		self:AddStatWeightRow(wndWeights, "Moxie", 1, nCritSevRatingDiff * nMoxieCritSev + nCritRatingDiff * nMoxieCrit, nCritSevRatingAEP * nMoxieCritSev + nCritRatingAEP * nMoxieCrit )
		self:AddStatWeightRow(wndWeights, "Tech", 1, nAPDiff * nTechAP, nTechAP )
	end
	wndWeights:ArrangeChildrenVert()
end

function SassyMedicSim:GetCritSeverityRatingValue()
	local nAMPs = 0
	if not (self.tSimStats and self.tSimStats.tAMPs) then
		return 0
	end
	if self.tSimStats.tAMPs["Critical Hit Severity III"] then
		nAMPs = 3
	elseif self.tSimStats.tAMPs["Critical Hit Severity II"] then
		nAMPs = 2
	elseif self.tSimStats.tAMPs["Critical Hit Severity I"] then
		nAMPs = 1
	end
	local nCritSevRating = self:Round((1441.26203132603 / ( 0 - ( self.tSimStats.nCritSev - 1.5 - (0.04 * nAMPs) - 0.71428573177128 ))) - 2017.76659344462)
	local nModCritSev = (1.5 + 0.04 * nAMPs + 0.71428573177128 - 1441.26203132603 / (nCritSevRating + 1 + 2017.76659344462)) - self.tSimStats.nCritSev
	return nModCritSev
end

function SassyMedicSim:AddStatWeightRow(wndParent, strName, nUnit, nDPS, nAEP)
	if not strName then
		return
	end
	local wndRow = Apollo.LoadForm(self.xmlDoc, "StatWeightRow", wndParent, self)
	if nUnit < 1 then
		nUnit = self:Round(nUnit * 100).."%"
	end
	wndRow:FindChild("StatName"):SetText(nUnit.." "..strName)
	wndRow:FindChild("DPS"):SetText("+"..self:Round(nDPS,2,true).." DPS")
	wndRow:FindChild("EP"):SetText(self:Round(nAEP,2,true).." EP")
	local nRows = #wndParent:GetChildren()
	if nRows % 2 == 0 then
		wndRow:SetBGColor(ktColors["MedLight"])
	end	
end

function SassyMedicSim:IncludeBreakpointsCheck( wndHandler, wndControl, eMouseButton )
	self.tConfig.bIncludeBreakpoints = wndControl:IsChecked()
	self:UpdateStatWeightWindow()
end

function SassyMedicSim:SpellDetailClick( wndHandler, wndControl )
	if wndHandler ~= wndControl then
		return
	end
	local wndSpellBreakdown = self.wndMain:FindChild("SpellBreakdown")
	local wndSpellBreakdown2 = self.wndMain:FindChild("SpellBreakdown2")
	if self.strCurrentSpellDetail then
		self.strCurrentSpellDetail = nil
		wndSpellBreakdown2:Show(false,true)
		wndSpellBreakdown:Show(true,true)
		self:DrawTimeline()
	else
		local strSpellName = wndControl:GetData()
		if not (strSpellName and self.tSimResults[strSpellName]) then
			return
		else
			self.strCurrentSpellDetail = strSpellName
			local tResults = self.tSimResults[strSpellName]
			wndSpellBreakdown2:DestroyChildren()
			local wndTitle = Apollo.LoadForm(self.xmlDoc,"SpellDetails",wndSpellBreakdown2,self)
			wndTitle:FindChild("SpellName"):SetText(self:GetLocalSpellName(strSpellName))
			wndTitle:FindChild("DPS"):SetText(self:Round(tResults.Damage/self.nSimulationTime,2,true).." DPS")
			self:SetSpellIcon(wndSpellBreakdown2:FindChild("Icon"),strSpellName)
			tResults.TotalAttacks = tResults.Hits + tResults.Crits + tResults.Deflects
			local tDetails = { { "Casts" , tResults.Casts },{"Attacks", tResults.TotalAttacks } }
			if tResults.Hits > 0 then
				table.insert(tDetails, { "Hits" , tResults.Hits .. " (" .. self:Round( (tResults.Hits / tResults.TotalAttacks) * 100, 2, true) .. "%)" } )
			else
				table.insert(tDetails, { "Hits" , "0 (0.00%)" } )
			end
			if tResults.Crits > 0 then
				table.insert(tDetails, { "Crits" , tResults.Crits .. " (" .. self:Round( (tResults.Crits / tResults.TotalAttacks) * 100, 2, true) .. "%)" } )
			else
				table.insert(tDetails, { "Crits" , "0 (0.00%)" } )
			end
			if tResults.Deflects > 0 then
				table.insert(tDetails, { "Deflects" , tResults.Deflects .. " (" .. self:Round( (tResults.Deflects / tResults.TotalAttacks) * 100, 2, true) .. "%)" } )
			else
				table.insert(tDetails, { "Deflects" , "0 (0.00%)" } )
			end
			if tResults.CritDamage + tResults.HitDamage > 0 then
				table.insert(tDetails, { "Avg Attack Dmg" , self:Round( ( tResults.CritDamage + tResults.HitDamage ) / tResults.TotalAttacks , 2, true ) } )
				table.insert(tDetails, { "Avg NonDeflect Dmg" , self:Round( ( tResults.CritDamage + tResults.HitDamage ) / ( tResults.TotalAttacks - tResults.Deflects ) , 2, true ) } )
			else	
				table.insert(tDetails, { "Avg Attack Dmg" , "0.00" } )
				table.insert(tDetails, { "Avg NonDeflect Dmg" , "0.00" } )
			end
			if tResults.Hits > 0 then
				table.insert(tDetails, { "Avg Hit Dmg" , self:Round(tResults.HitDamage / tResults.Hits, 2, true)  } )
			else
				table.insert(tDetails, { "Avg Hit Dmg" , "0.00"  } )
			end
			if tResults.Crits > 0 then
				table.insert(tDetails, { "Avg Crit Dmg" , self:Round(tResults.CritDamage / tResults.Crits, 2, true)	} )
			else
				table.insert(tDetails, { "Avg Crit Dmg" , "0.00"  } )
			end
			
			for k,tDetail in pairs(tDetails) do
				local wndDetail = Apollo.LoadForm(self.xmlDoc,"SpellDetails2",wndSpellBreakdown2,self)
				if tDetail[1] == "Hits" or tDetail[1] == "Crits" or tDetail[1] == "Deflects" then
					wndDetail:FindChild("Bar"):SetAnchorPoints(0,0,tResults[tDetail[1]]/tResults.TotalAttacks,1)
				end
				if k%2 == 1 then
					wndDetail:FindChild("Bar"):SetBGColor(ktColors["MedLight"])
				end
				wndDetail:FindChild("Title"):SetText(tDetail[1])
				wndDetail:FindChild("Data"):SetText(tDetail[2])
			end
			wndSpellBreakdown2:ArrangeChildrenVert()
			wndSpellBreakdown:Show(false,true)			
			wndSpellBreakdown2:Show(true,true)
			self:DrawTimeline(strSpellName)
		end
	end	
end

function SassyMedicSim:UpdateVisualisation()
	self.bVisRunning = true
	local wndProgress = self.wndMain:FindChild("VisProgress")
	local nL,nT,nR,nB = self.wndMain:FindChild("GraphBG"):GetAnchorPoints()
	wndProgress:SetAnchorPoints(nL,nT,nR,nB)
	local nL,nT,nR,nB = self.wndMain:FindChild("GraphBG"):GetAnchorOffsets()
	wndProgress:SetAnchorOffsets(nL,nT,nR,nB)
	wndProgress:Show(true,true)
	wndProgress:FindChild("ProgressBar"):SetMax(1)
	wndProgress:FindChild("ProgressBar"):SetProgress(0)
	self:UpdateSpellBreakdown()
	self:CleanGraphs()
	self:InitialiseDPSGraph()
	self:InitialiseActuatorGraph()
	self:DrawTimeline()
	self:DrawCombatLog(1)
	Apollo.RegisterEventHandler("NextFrame","VisualisationFrame",self)
end

function SassyMedicSim:UpdateSpellBreakdown()
	local nTotalDamage = 0
	for strSpellName,tResults in pairs(self.tSimResults) do
		nTotalDamage = nTotalDamage + tResults.Damage
	end
	local tSortedResults = {}
	for strSpellName in pairs(self.tSimResults) do
		table.insert(tSortedResults,strSpellName)
	end
	table.sort(tSortedResults, function (a,b) return self.tSimResults[a].Damage > self.tSimResults[b].Damage end)
	local wndSpellBreakdown = self.wndMain:FindChild("SpellBreakdown")
	wndSpellBreakdown:DestroyChildren()
	local wndSpellDetails = Apollo.LoadForm(self.xmlDoc,"SpellDetails",wndSpellBreakdown,self)
	wndSpellDetails:FindChild("SpellName"):SetText("Total")
	wndSpellDetails:FindChild("DPS"):SetText(self:Round(nTotalDamage/self.nSimulationTime,2,true).." DPS")
	for k,strSpellName in ipairs(tSortedResults) do
		local wndSpellDetails = Apollo.LoadForm(self.xmlDoc,"SpellDetails",wndSpellBreakdown,self)
		wndSpellDetails:FindChild("SpellName"):SetText(self:GetLocalSpellName(strSpellName))
		self:SetSpellIcon(wndSpellDetails:FindChild("Icon"),strSpellName)
		local nPercentDamage = self:Round((self.tSimResults[strSpellName].Damage/nTotalDamage)*100,2,true)
		wndSpellDetails:FindChild("DPS"):SetText(self:Round(self.tSimResults[strSpellName].Damage/self.nSimulationTime,2,true).." ("..nPercentDamage.."%)")
		if k%2 == 1 then
			wndSpellDetails:FindChild("Bar"):SetBGColor(ktColors["MedLight"])
		end
		wndSpellDetails:FindChild("Bar"):SetAnchorPoints(0,0,nTotalDamage/self.nSimulationTime,1)
		wndSpellDetails:SetData(strSpellName)
	end
	wndSpellBreakdown:ArrangeChildrenVert()
	wndSpellBreakdown:Show(true,true)
	self.wndMain:FindChild("SpellBreakdown2"):Show(false,true)
	self.strCurrentSpellDetail = nil
end

function SassyMedicSim:CleanGraphs()
	local wndGraphBG = self.wndMain:FindChild("GraphBG")
	for _,wndChild in pairs(wndGraphBG:GetChildren()) do
		wndChild:DestroyAllPixies()
	end
	wndGraphBG:SetHScrollPos(0)
end

function SassyMedicSim:UpdateGraphBG()
	local wndGraphBG = self.wndMain:FindChild("GraphBG")
	local nParentWidth = wndGraphBG:GetWidth()
	local nChildWidth = nParentWidth
	local nW
	for k,wndChild in pairs(wndGraphBG:GetChildren()) do
		if not nW then
			nW = wndChild:GetWidth()
		end
		nW = math.max(nW,nParentWidth)
		if wndChild:GetWidth() ~= nW then
			local nT,nL,nR,nB = wndChild:GetAnchorOffsets()
			wndChild:SetAnchorOffsets(nT,nL,nW,nB)
		end
	end
	wndGraphBG:SetHScrollInfo(nW-nParentWidth,nParentWidth,50)
end

function SassyMedicSim:DrawTimeline(strEvent)
	local wndLine = self.wndMain:FindChild("Timeline")
	wndLine:DestroyAllPixies()
	if not (strEvent and self.tSimResults[strEvent] ) then
		return
	end
	local nT,nL,nR,nB = wndLine:GetAnchorOffsets()
	wndLine:SetAnchorOffsets(nT,nL,self.nSimulationTime * knInitialGraphScale,nB)
	local tEvents
	local tNonCastDamage = {
		["Assassin"] = true,
		["Impact"] = true,
		["Dev Probe Explosion"] = true,
		["Echo Burst"] = true,
		["Fire Starter"] = true,
		["Shadow Blast"] = true,
		["Meltdown"] = true,		
	}
	if tNonCastDamage[strEvent] then
		tEvents = self.tSimDamageEvents
	else
		tEvents = self.tSimCastEvents
	end
	local nLastTime = -1
	local nCount = 0
	for k,tCastEvent in ipairs(tEvents) do
		if tCastEvent.strSpellName == strEvent and tCastEvent.nTime ~= nLastTime then
			nLastTime = tCastEvent.nTime
			local clr = ktColors["Timeline" .. (nCount % 3 + 1 )]
					nCount = nCount + 1
			local nDur = math.max(tCastEvent.nDuration or 0.25,0.25)
			self:DrawSquare(wndLine,self.nSimulationTime,1,tCastEvent.nTime,1,tCastEvent.nTime+nDur,0,clr)
		end
	end
	
end

function SassyMedicSim:InitialiseDPSGraph()
	local wndGraph = self.wndMain:FindChild("DPSGraph")
	local nT,nL,nR,nB = wndGraph:GetAnchorOffsets()
	wndGraph:SetAnchorOffsets(nT,nL,self.nSimulationTime * knInitialGraphScale,nB)
	self.tVisDPS = {}
	self.tVisDPS.bRunning = true
	self.tVisDPS.tPoints = {}
	self.tVisDPS.nMaxDPS = 0
	self.tVisDPS.nBegin = #self.tSimDamageEvents
	self.tVisDPS.nStep = 1 --self.nSimulationTime/(wndGraph:GetWidth()/2)
	self.tVisDPS.nPeriod = 4 --self.tVisDPS.nStep * 4 -- seconds over which "current" DPS is measured
	self.tVisDPS.nStart = self.nSimulationTime
	self.tVisDPS.nPixie = 1
end

function SassyMedicSim:ProcessDPSGraph()
	if not self.tVisDPS.bRunning then
		return
	end
	if not self.tVisDPS.bDrawingPixies then
		for n = self.tVisDPS.nStart,math.max(self.tVisDPS.nStart - knDPSVisualisationSecondsPerFrame, 0), -self.tVisDPS.nStep do
			local nTime = n
			if nTime <= 0 then
				nTime = 0
				self.tVisDPS.bDrawingPixies = true
			end
			local nLastEvent
			local nDamage = 0
			for i = self.tVisDPS.nBegin,1,-1 do
				if self.tSimDamageEvents[i].nTime >= nTime - self.tVisDPS.nPeriod then
					if self.tSimDamageEvents[i].nTime > nTime then
						self.tVisDPS.nBegin = i - 1
					else
						nDamage = nDamage + self.tSimDamageEvents[i].nDamage
					end
				else
					break
				end
			end
			table.insert(self.tVisDPS.tPoints,{ ["x"] = nTime, ["y"] = nDamage } )
			if nDamage > self.tVisDPS.nMaxDPS then
				self.tVisDPS.nMaxDPS = nDamage
			end
		end
	end
	if self.tVisDPS.bDrawingPixies then
		local wndGraph = self.wndMain:FindChild("DPSGraph")
		local nGraphXMax = self.nSimulationTime
		local nGraphYMax = self.tVisDPS.nMaxDPS
		for i = self.tVisDPS.nPixie,math.min(#self.tVisDPS.tPoints-1,self.tVisDPS.nPixie+knPixiesPerFrame) do
			self:DrawLine(wndGraph, nGraphXMax, nGraphYMax, self.tVisDPS.tPoints[i].x, self.tVisDPS.tPoints[i].y, 
						self.tVisDPS.tPoints[i+1].x, self.tVisDPS.tPoints[i+1].y, ktColors["DPSGraph"], 2
						)
			if i == #self.tVisDPS.tPoints - 1 then
				self.tVisDPS.bRunning = false
			else
				self.tVisDPS.nPixie = i + 1
			end
		end
	else
		self.tVisDPS.nStart = math.max(self.tVisDPS.nStart - knDPSVisualisationSecondsPerFrame - self.tVisDPS.nStep, 0)
	end
end

function SassyMedicSim:InitialiseActuatorGraph()
	local wndGraph = self.wndMain:FindChild("ActuatorGraph")
	local nT,nL,nR,nB = wndGraph:GetAnchorOffsets()
	wndGraph:SetAnchorOffsets(nT,nL,self.nSimulationTime * knInitialGraphScale,nB)
	self.tVisActuators = {}
	self.tVisActuators.tPoints = {}
	self.tVisActuators.nStart = 1
	self.tVisActuators.bRunning = true
	self.tVisActuators.nPixie = 1
end

function SassyMedicSim:ProcessActuatorGraph()
	if not self.tVisActuators.bRunning then
		return
	end
	if not self.tVisActuators.bDrawingPixies then
		local nLastKey
		for nEventKey = self.tVisActuators.nStart,math.min(self.tVisActuators.nStart+knActuatorVisualisationEventsPerFrame,#self.tSimActuatorEvents) do
			local tEvent = self.tSimActuatorEvents[nEventKey]
			if nEventKey ~= #self.tSimActuatorEvents and self.tSimActuatorEvents[nEventKey+1].nTime < tEvent.nTime then
				self.tSimActuatorEvents[nEventKey],self.tSimActuatorEvents[nEventKey+1] = self.tSimActuatorEvents[nEventKey+1],self.tSimActuatorEvents[nEventKey]
			end
			if nEventKey == #self.tSimActuatorEvents or self.tSimActuatorEvents[nEventKey+1].nTime ~= tEvent.nTime then
				table.insert(self.tVisActuators.tPoints, { ["x"] = tEvent.nTime, ["y"] = tEvent.nActuators })
			end
			nLastKey = nEventKey
		end
		if nLastKey == #self.tSimActuatorEvents then
			self.tVisActuators.bDrawingPixies = true
		else			
			self.tVisActuators.nStart = nLastKey + 1
		end
	end
	if self.tVisActuators.bDrawingPixies then
		local nGraphXMax = self.nSimulationTime
		local nGraphYMax = 4
		local wndGraph = self.wndMain:FindChild("ActuatorGraph")
		local bPixiesDone
		if #self.tVisActuators.tPoints > 1 then
			for i = self.tVisActuators.nPixie,math.min(#self.tVisActuators.tPoints-1, self.tVisActuators.nPixie + math.floor(knPixiesPerFrame/4)) do
				for y = 1,4 do
					if self.tVisActuators.tPoints[i].y >= y then
						local clr = ktColors["ActuatorGraph1"]
						if y%2 == 1 then
							clr = ktColors["ActuatorGraph2"]
						end
						self:DrawSquare(wndGraph,nGraphXMax,nGraphYMax,self.tVisActuators.tPoints[i].x,y,self.tVisActuators.tPoints[i+1].x,y-1,clr)
					else
						break
					end
				end
				if i >= #self.tVisActuators.tPoints - 1 then
					bPixiesDone = true
				else
					self.tVisActuators.nPixie = i + 1
				end
			end
		else
			bPixiesDone = true
		end
		if bPixiesDone then
			self.tVisActuators.bRunning = false
		end
	end
end

function SassyMedicSim:VisualisationFrame()
	if self:Paused() then
		return
	end
	local bProcessing
	if self.tVisDPS and self.tVisDPS.bRunning then
		bProcessing = true
		self:ProcessDPSGraph()
	end
	if self.tVisActuators and self.tVisActuators.bRunning then
		bProcessing = true
		self:ProcessActuatorGraph()
	end
	if bProcessing then
		local wndProgress = self.wndMain:FindChild("VisProgress"):FindChild("ProgressBar")
		local nProgress = ((self.nSimulationTime - self.tVisDPS.nStart) / self.nSimulationTime ) * (self.tVisActuators.nStart/#self.tSimActuatorEvents)
						  * ( self.tVisDPS.nPixie / #self.tVisDPS.tPoints ) * ( self.tVisActuators.nPixie / #self.tVisActuators.tPoints )
		wndProgress:SetProgress(nProgress)		
	else
		self.bVisRunning = false
		Apollo.RemoveEventHandler("NextFrame",self)
		self.wndMain:FindChild("VisProgress"):Show(false,true)
		self:ActivateNavButtons(true)
		self:UpdateGraphBG()
	end
end

function SassyMedicSim:DrawMultiSimHisto(tDistribution,nMaxProb,nMean,nMedian,nMin,nMax,nStdDev)
	local wndHistoBG = self.wndMain:FindChild("MultiSimHistoBG")
	local wndHisto = wndHistoBG:FindChild("MultiSimHisto")
	local nHistoL,nHistoR = 0.0125, 0.9875
	local nHistoW = nHistoR - nHistoL
	local nGraphXMin = math.floor(tDistribution[1].nDPS/500)*500
	local nGraphXMax = math.floor(tDistribution[#tDistribution].nDPS/500+1)*500
	wndHisto:DestroyAllPixies()
	for _,wndChild in pairs(wndHistoBG:GetChildren()) do
		if wndChild:GetName() == "HistoDPS" then
			wndChild:Destroy()
		end
	end
	self:DrawLine(wndHisto,1,1,0,0,1,0, { a = 1, r = 1, g = 1, b = 1 } ,2)
	for nDPS = nGraphXMin,nGraphXMax,100 do
		local tClr = { a = 0.33, r = 1, g = 1, b = 1 }
		if nDPS % 500 == 0 then
			local wndLabel = Apollo.LoadForm(self.xmlDoc,"HistoDPS",wndHistoBG,self)
			wndLabel:SetText((nDPS/1000).."k")
			local nL,nT,nR,nB = wndLabel:GetAnchorPoints()
			nL = ((nDPS- nGraphXMin) / (nGraphXMax - nGraphXMin)) * nHistoW + nHistoL
			nR = ((nDPS- nGraphXMin) / (nGraphXMax - nGraphXMin)) * nHistoW + nHistoL	
			wndLabel:SetAnchorPoints(nL,nT,nR,nB)
			tClr.a = 1
		end
		self:DrawLine(wndHisto,nGraphXMax-nGraphXMin,1,nDPS-nGraphXMin,0,nDPS-nGraphXMin,1,tClr,2)
	end
	self:DrawLine(wndHisto,nGraphXMax-nGraphXMin,nMaxProb,tDistribution[1].nDPS-nGraphXMin,0,tDistribution[1].nDPS-nGraphXMin,tDistribution[1].nProb)
	for k,tDist in ipairs(tDistribution) do
		if k ~= #tDistribution then
			local tNextDist = tDistribution[k+1]
			self:DrawLine(wndHisto,nGraphXMax-nGraphXMin,nMaxProb,tDist.nDPS-nGraphXMin,tDist.nProb,tNextDist.nDPS-nGraphXMin,tNextDist.nProb)
		else
			self:DrawLine(wndHisto,nGraphXMax-nGraphXMin,nMaxProb,tDist.nDPS-nGraphXMin,tDist.nProb,tDist.nDPS-nGraphXMin,0)
		end
	end
	local strText = "Mean DPS = " .. nMean .. "\nMedian DPS = " .. nMedian .. "\nLowest DPS = " .. nMin .. "\nHighest DPS = " .. nMax .. "\nStd Dev = " .. nStdDev
	self.wndMain:FindChild("MultiSimText"):SetText(strText)
	wndHisto:Show(true)
end

function SassyMedicSim:DrawLine(wnd,nGraphXMax,nGraphYMax,x1,y1,x2,y2,clr,nW)
	if not nW then
		nW = 2
	end
	if not clr then
		clr = {a = 1,r = 1,b = 1, g = 1}
	end
	local tLoc = {
    	["fPoints"] = {x1/nGraphXMax,1-(y1/nGraphYMax),x2/nGraphXMax,1-(y2/nGraphYMax)},
	    ["nOffsets"] = {0,0,0,0}
	}
	return wnd:AddPixie({
		["bLine"] = true,
		["fWidth"] = nW,
		["loc"] = tLoc,
		["cr"] = clr,
	})
end

function SassyMedicSim:DrawSquare(wnd,nGraphXMax,nGraphYMax,x1,y1,x2,y2,clr)
	if not clr then
		clr = {a = 1,r = 1,b = 1, g = 1}
	end
	tLoc = {
    	["fPoints"] = {x1/nGraphXMax,1-(y1/nGraphYMax),x2/nGraphXMax,1-(y2/nGraphYMax)},
	    ["nOffsets"] = {0,0,0,0}
	}
	wnd:AddPixie({
		["strSprite"] = "WhiteFill",
		["loc"] = tLoc,
		["cr"] = clr,
	})
end

function SassyMedicSim:GetButtonXml()
	local tXmlButton = {
		["__XmlNode"] = "Forms",
		{				
			["__XmlNode"] = "Form",
			["Class"] = "Button",
			["Base"] = "SassyMedicSimSprites:NewButton",
			["Font"] = "CRB_Interface10_BB",
			["ButtonType"] = "Check",
			["LAnchorPoint"] = "0",
			["LAnchorOffset"] = "0",
			["TAnchorPoint"] = "0",
			["TAnchorOffset"] = "0",
			["RAnchorPoint"] = "1",
			["RAnchorOffset"] = "0",
			["BAnchorPoint"] = "1",
			["BAnchorOffset"] = "0",
			["DT_VCENTER"] = "1",
			["DT_CENTER"] = "1",
			["BGColor"] = "ffffffff",
			["TextColor"] = "ffffffff",
			["NormalTextColor"] = "ffffffff",
			["PressedTextColor"] = "ff96def1",
			["FlybyTextColor"] = "ffffffff",
			["PressedFlybyTextColor"] = "ff96def1",
			["DisabledTextColor"] = "ffa6bcc3",
			["TooltipType"] = "OnCursor",
			["Name"] = "InterfaceButton",
			["TooltipColor"] = "",
			["Sprite"] = "",
			["Picture"] = "0",
			["Text"] = "ButtonText",
			["TextId"] = "",
			["DrawAsCheckbox"] = "0",
			["DrawClientSprite"] = "0",
			["CheckboxRight"] = "0",
			["Border"] = "0",
			["Overlapped"] = "1",
			["Tooltip"] = "",
		}
	}
	return tXmlButton
end

function SassyMedicSim:ChangeXmlAttribute(tXml, strAttribute, luaValue)
	tXml[1][strAttribute] = luaValue
	return tXml
end

function SassyMedicSim:GraphMouseWheel( wndHandler, wndControl, nLastRelativeMouseX, nLastRelativeMouseY, fScrollAmount, bConsumeMouseWheel )
	if wndHandler ~= wndControl then
		return
	end
	if not self.nSimulationTime then
		return
	end
	local tScales = {0.05,0.1,0.2,0.5,1,2,4}
	local nParentWidth = wndControl:GetWidth()
	local nOldPos = wndControl:GetHScrollPos()
	local nW,nOldW
	for k,wndChild in pairs(wndControl:GetChildren()) do
		if not nW then
			nW = wndChild:GetWidth()
			nOldW = nW
			local nCurrentScale = self.nSimulationTime / nW
			local nScaleKey = 1
			local bFound
			for k,v in pairs(tScales) do
				if nCurrentScale == v then
					nScaleKey = k
					bFound = true
				end
			end
			if not bFound then
				table.insert(tScales,nCurrentScale)
				table.sort(tScales)
				for k,v in pairs(tScales) do
					if nCurrentScale == v then
						nScaleKey = k
					end
				end
			end
			if fScrollAmount < 0 then
				nScaleKey = math.min(nScaleKey + 1,#tScales)
			else
				nScaleKey = math.max(nScaleKey - 1,1)
			end
			nW = self.nSimulationTime / tScales[nScaleKey]
			if nW < nParentWidth then
				nW = nParentWidth
			end
		end
		local nT,nL,nR,nB = wndChild:GetAnchorOffsets()
		wndChild:SetAnchorOffsets(nT,nL,nW,nB)
	end
	self:UpdateGraphBG()
	wndControl:SetHScrollPos(( nOldPos + nLastRelativeMouseX ) * (nW/nOldW) - nLastRelativeMouseX )
end

function SassyMedicSim:CombatLogSelectByTime(nTime)
	local nUBound = #self.tSimpleSimLog
	local nLBound = 0
	local nCandidate
	local bBestCandidateFound
	while not bBestCandidateFound do
		nCandidate = math.floor((nUBound+nLBound+0.5)/2)
		local tCandidate = self:GetSimpleLogEvent(nCandidate)
		if tCandidate.nTime < nTime then
			nLBound = nCandidate
		elseif tCandidate.nTime > nTime then
			nUBound = nCandidate
		else -- tCandidate.nTime == nTime
			bBestCandidateFound = true
		end
		if nUBound - nLBound < 2 then
			bBestCandidateFound = true
		end
	end
	local tCandidate = self:GetSimpleLogEvent(nCandidate)
	local tNextCandidate = self:GetSimpleLogEvent(nCandidate+1)
	local tPrevCandidate = self:GetSimpleLogEvent(nCandidate-1)
	if tNextCandidate and math.abs(tNextCandidate.nTime-nTime) < math.abs(tCandidate.nTime-nTime) then
		nCandidate = nCandidate + 1
	elseif tPrevCandidate and math.abs(tPrevCandidate.nTime-nTime) < math.abs(tCandidate.nTime-nTime) then
		nCandidate = nCandidate - 1				
	end
	local nCandidateTime = self:GetSimpleLogEvent(nCandidate).nTime
	for i = nCandidate,1,-1 do
		local tCandidate = self:GetSimpleLogEvent(i)
		if tCandidate.nTime == nCandidateTime then
			nCandidate = i
		else
			break
		end
	end
	self:DrawCombatLog(nCandidate,nCandidate)
end

function SassyMedicSim:DrawCombatLog(nEvent,nSelect)
	local wndCombatLog = self.wndMain:FindChild("CombatLog")
	wndCombatLog:DestroyChildren()
	self.nCombatLogPage = math.floor((nEvent - 1) / knCombatLogPageSize) + 1
	local nStart = (self.nCombatLogPage - 1 ) * knCombatLogPageSize + 1
	local nEnd = math.min(self.nCombatLogPage * knCombatLogPageSize,#self.tSimpleSimLog)
	local bSelect
	local nStartTime,nEndTime
	for nEvent = nStart,nEnd do
		local tEvent = self:GetSimpleLogEvent(nEvent)
		if not tEvent.strTooltipText then
			if tEvent.strEventType == "Actuator" then
				local strSym = ""
				if tEvent.bModify and tEvent.nAmount > 0 then
					strSym = "+"
				end
				tEvent.strTooltipText = strSym .. tEvent.nAmount .. " Actuators (".. tEvent.nActuators .. ") " .. tEvent.strSource
			elseif tEvent.strEventType == "Cast" then
				tEvent.strTooltipText = tEvent.strSpellName.." cast ("..self:Round(tEvent.nDuration,2,true).."s)"
			elseif tEvent.strEventType == "Damage" then
				local strHitType
				for k,v in pairs(ktCodeEnumSpellResults) do
					if v == tEvent.nHitType then
						strHitType = k
					end
				end
				tEvent.strTooltipText = tEvent.strSpellName .. " " .. string.lower(strHitType) .. "s for ".. self:Round(tEvent.nDamage,0)
			end
			self.tSimpleSimLog[nEvent].strTooltipText = tEvent.strTooltipText
		end
		local wndEvent = Apollo.LoadForm(self.xmlDoc,"CombatLogRow",wndCombatLog,self)
		wndEvent:FindChild("Time"):SetText(self:FormatTime(tEvent.nTime))
		wndEvent:FindChild("Data"):SetText(tEvent.strTooltipText)
		wndEvent:SetData(nEvent)
		if nEvent == nSelect then
			wndEvent:SetBGColor(ktColors["MedLight"])
			bSelect = true
			self:UpdateGraphSelectionLine(tEvent.nTime)
		end
		if nEvent == nStart then
			nStartTime = tEvent.nTime
		elseif nEvent == nEnd then
			nEndTime = tEvent.nTime
		end
	end
	local nMaxPage = math.floor((#self.tSimpleSimLog - 1) / knCombatLogPageSize) + 1
	wndCombatLog:GetParent():FindChild("PrevPage"):Enable(self.nCombatLogPage > 1)
	wndCombatLog:GetParent():FindChild("NextPage"):Enable(self.nCombatLogPage < nMaxPage)
	wndCombatLog:GetParent():FindChild("CombatLogPageText"):SetText("Page "..self.nCombatLogPage.."/".. nMaxPage .."\n"..self:FormatTime(nStartTime or 0).."-"..self:FormatTime(nEndTime or 0))
	local tLogChildren = wndCombatLog:GetChildren()
	local nL,nT,nR,nB = tLogChildren[1]:GetAnchorOffsets()
	local nH = nB - nT
	wndCombatLog:ArrangeChildrenVert()
	local nScrollPos = 0
	if bSelect then
		nScrollPos = (nSelect % knCombatLogPageSize) * nH - nH
	end
	wndCombatLog:SetVScrollPos(nScrollPos)
end

function SassyMedicSim:GetSimpleLogEvent(nKey)
	if not nKey then
		return
	end
	if nKey < 1 or nKey > #self.tSimpleSimLog then
		return
	end
	local tEvent
	if self.tSimpleSimLog[nKey].nType == ktEventType["Cast"] then
		tEvent = self.tSimCastEvents[self.tSimpleSimLog[nKey].nKey]
		tEvent.strEventType = "Cast"
	elseif self.tSimpleSimLog[nKey].nType == ktEventType["Actuator"] then
		tEvent = self.tSimActuatorEvents[self.tSimpleSimLog[nKey].nKey]
		tEvent.strEventType = "Actuator"		
	elseif self.tSimpleSimLog[nKey].nType == ktEventType["Damage"] then
		tEvent = self.tSimDamageEvents[self.tSimpleSimLog[nKey].nKey]
		tEvent.strEventType = "Damage"
	end
	return tEvent
end

function SassyMedicSim:GraphMouseDown( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY, bDoubleClick, bStopPropagation )
	if wndControl ~= wndHandler then
		return
	end
	if not self.nSimulationTime then -- if no sim has been run
		return
	end
	if self.bVisRunning or self.bSimRunning then
		return
	end
	local wndGraphBG = self.wndMain:FindChild("GraphBG")
	local wndGraph = self.wndMain:FindChild("DPSGraph")
	local nPos = wndGraphBG:GetHScrollPos()
	local nWidth = wndGraph:GetWidth()
	local nScale = self.nSimulationTime/nWidth  -- seconds per pixel
	local nTime = ( nLastRelativeMouseX + nPos ) * nScale
	self:CombatLogSelectByTime(nTime)
end

function SassyMedicSim:UpdateGraphSelectionLine(nTime)
	local wndGraphOverlay = self.wndMain:FindChild("GraphUIOverlay")
	local nX = nTime/self.nSimulationTime
	local tLoc = {
    	["fPoints"] = {nX,0,nX,1},
	    ["nOffsets"] = {0,0,0,0}
	}
	local tPixieData = {
		["bLine"] = true,
		["fWidth"] = 2,
		["loc"] = tLoc,
		["cr"] = ktColors["GraphSelectionLine"],
	}
	if not self.nGraphSelectionLineId then
		self.nGraphSelectionLineId = wndGraphOverlay:AddPixie(tPixieData)
	else
		wndGraphOverlay:UpdatePixie(self.nGraphSelectionLineId,tPixieData)
	end
end

function SassyMedicSim:FormatTime(nRawTime)
	local nTime = math.floor(nRawTime)
	local nDecimals = math.floor((nRawTime - nTime)*100)
	local nSeconds = nTime % 60
	local nMinutes = (( nTime - nSeconds ) / 60 ) --% 60
--	local nHours = ( nTime - nSeconds - nMinutes * 60 ) / 3600
	local strDecimals = string.rep("0",2-string.len(tostring(nDecimals)))..nDecimals
	local strSeconds = string.rep("0",2-string.len(tostring(nSeconds)))..nSeconds
	local strMinutes = string.rep("0",2-string.len(tostring(nMinutes)))..nMinutes
--	local strHours = string.rep("0",1-string.len(tostring(nHours)))..nHours
	return strMinutes..":"..strSeconds.."."..strDecimals
end

function SassyMedicSim:PauseButtonCheck( wndHandler, wndControl, eMouseButton )
	self.bPaused = wndControl:IsChecked()
end

function SassyMedicSim:CancelSimButton( wndHandler, wndControl, eMouseButton )
	self:CancelSimulation()
end

function SassyMedicSim:SpeedButtonCheck( wndHandler, wndControl, eMouseButton )
	local strName = wndControl:GetName()
	local n = string.sub(strName,string.len(strName))
	self.tConfig.nSimSpeed = tonumber(n)
end

function SassyMedicSim:CombatLogPrevPageButton( wndHandler, wndControl, eMouseButton )
	if wndHandler ~= wndControl then
		return
	end
	self:DrawCombatLog((self.nCombatLogPage - 1) * knCombatLogPageSize)
end

function SassyMedicSim:CombatLogNextPageButton( wndHandler, wndControl, eMouseButton )
	if wndHandler ~= wndControl then
		return
	end
	self:DrawCombatLog((self.nCombatLogPage + 1) * knCombatLogPageSize)
end

function SassyMedicSim:CombatLogRowClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if wndHandler ~= wndControl then
		return
	end
	local wndCombatLog = self.wndMain:FindChild("CombatLog")
	for _,wndChild in pairs(wndCombatLog:GetChildren()) do
		if wndChild == wndControl then
			wndChild:SetBGColor(ktColors["MedLight"])
		else
			wndChild:SetBGColor(ktColors["Medium"])
		end
	end
	local tEvent = self:GetSimpleLogEvent(wndControl:GetData())
	self:UpdateGraphSelectionLine(tEvent.nTime)
end

function SassyMedicSim:ConfigDefaultButton( wndHandler, wndControl, eMouseButton )
	local strParentName = wndControl:GetParent():GetName()
	local strControlName = wndControl:GetName()
	if strParentName == "LASBG" then
		if strControlName == "DefaultsButton" then
			self.tConfig.tSpellPriorities = self:GetDefaultPriorityList()
		elseif strControlName == "SyncButton" then
			self.tConfig.tSpells = self:GetPlayerSpells()
		end
		self:UpdateConfigAbilityWindow()
	elseif strParentName == "StatsBG" then
		self:SyncStats()
		self:UpdateConfigStatsWindow()
	elseif strParentName == "AMPsBG" then
		self:SyncAMPs()
		self:SyncRuneSets()
		self:UpdateConfigAMPsWindow()
	elseif strParentName == "SpecialsBG" then
		self:SetGadgetToDefaults()
		self:SetSpecialsToDefaults()
		self:UpdateConfigSpecialsWindow()
	elseif strParentName == "MiscBG" then
		self:SetMiscOptionsToDefaults()
		self:UpdateConfigMiscWindow()
	elseif strParentName == "ConfigurationTab" then
		if strControlName == "DefaultsButton" then
			self.tConfig.tSpellPriorities = self:GetDefaultPriorityList()
			self:SetGadgetToDefaults()
			self:SetSpecialsToDefaults()
			self:UpdateConfigSpecialsWindow()
			self:SetMiscOptionsToDefaults()
			self:UpdateConfigMiscWindow()
		end
		self.tConfig.tSpells = self:GetPlayerSpells()
		self:UpdateConfigAbilityWindow()
		self:SyncStats()
		self:UpdateConfigStatsWindow()
		self:SyncAMPs()
		self:SyncRuneSets()
		self:UpdateConfigAMPsWindow()
	end
end

function SassyMedicSim:UpdateConfigAbilityWindow()
	local wndList = self.wndMain:FindChild("LASBG"):FindChild("List")
	local nScrollPos = wndList:GetVScrollPos()
	wndList:DestroyChildren()
	for k,strAbility in ipairs(self.tConfig.tSpellPriorities) do
		local wndRow = Apollo.LoadForm(self.xmlDoc,"ConfigAbilityRow",wndList,self)
		wndRow:FindChild("AbilityName"):SetText(strAbility)
		self:SetSpellIcon(wndRow:FindChild("Icon"),strAbility)
		if not self.tConfig.tSpells[strAbility] then
			wndRow:FindChild("Icon"):SetBGColor(CColor.new(0.5,0.5,0.5))
		end
		wndRow:SetData(strAbility)
		if strAbility ~= "Energize" then
			local nSpellTier = 1
			if self.tConfig.tSpells[strAbility] then
				nSpellTier = GameLib.GetSpell(self.tConfig.tSpells[strAbility]):GetTier()
			end
			for nTier = 1,8 do
				local wndTierButton = wndRow:FindChild("Tier"..nTier)
				if nSpellTier > nTier then
					wndTierButton:SetBGColor(ktColors["Cyan"])
				else
					wndTierButton:SetBGColor(ktColors["MedDark"])		
				end
			end
		else
			for nTier = 1,8 do
				local wndTierButton = wndRow:FindChild("Tier"..nTier)
				wndTierButton:Show(false)
			end
		end
		if k == 1 then
			wndRow:FindChild("UpArrow"):Enable(false)
		end
		if k == #self.tConfig.tSpellPriorities then
			wndRow:FindChild("DownArrow"):Enable(false)
		end
	end
	wndList:ArrangeChildrenVert()
	wndList:SetVScrollPos(nScrollPos)
end

function SassyMedicSim:ConfigAbilityToggleClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if wndHandler ~= wndControl then
		return
	end
	local strAbility = wndControl:GetParent():GetParent():GetData()
	if self.tConfig.tSpells[strAbility] then
		self.tConfig.tSpells[strAbility] = nil
	else
		self.tConfig.tSpells[strAbility] = self:GetSpell(strAbility,1):GetId()
	end
	self:UpdateConfigAbilityWindow()
end

function SassyMedicSim:ConfigAbilityTierClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if wndHandler ~= wndControl then
		return
	end
	local strAbility = wndControl:GetParent():GetParent():GetParent():GetData()
	local nTier = tonumber(string.sub(wndControl:GetName(),5)) + 1
	self.tConfig.tSpells[strAbility] = self:GetSpell(strAbility,nTier):GetId()
	self:UpdateConfigAbilityWindow()
end

function SassyMedicSim:ConfigAbilityUpArrow( wndHandler, wndControl, eMouseButton )
	local strAbility = wndControl:GetParent():GetParent():GetData()
	local nKey
	for k,v in ipairs(self.tConfig.tSpellPriorities) do
		if v == strAbility then
			nKey = k
		end
	end
	if nKey and nKey ~= 1 then
		self.tConfig.tSpellPriorities[nKey],self.tConfig.tSpellPriorities[nKey-1] = self.tConfig.tSpellPriorities[nKey-1],self.tConfig.tSpellPriorities[nKey]
	end
	self:UpdateConfigAbilityWindow()
end

function SassyMedicSim:ConfigAbilityDownArrow( wndHandler, wndControl, eMouseButton )
	local strAbility = wndControl:GetParent():GetParent():GetData()
	local nKey
	for k,v in ipairs(self.tConfig.tSpellPriorities) do
		if v == strAbility then
			nKey = k
		end
	end
	if nKey and nKey ~= #self.tConfig.tSpellPriorities then
		self.tConfig.tSpellPriorities[nKey],self.tConfig.tSpellPriorities[nKey+1] = self.tConfig.tSpellPriorities[nKey+1],self.tConfig.tSpellPriorities[nKey]
	end
	self:UpdateConfigAbilityWindow()
end

function SassyMedicSim:UpdateConfigStatsWindow()
	local wndList = self.wndMain:FindChild("StatsBG"):FindChild("List")
	wndList:DestroyChildren()
	self.tConfig.tStats = self.tConfig.tStats or {}
	for k,tStat in ipairs(ktStats) do
		local wndRow = Apollo.LoadForm(self.xmlDoc,"ConfigStatRow",wndList,self)
		wndRow:SetData(k)
		wndRow:FindChild("Label"):SetText(tStat.strName)
		self.tConfig.tStats[tStat.strStat] = self.tConfig.tStats[tStat.strStat] or self:GetPlayerStat(tStat.strStat)
		local nAmount = self.tConfig.tStats[tStat.strStat]
		local nDiff = nAmount - self:GetPlayerStat(tStat.strStat)
		local strAmount,strDiff
		if tStat.strType == "percentage" then
			strAmount = self:Round(nAmount * 100,2,false)
			strDiff = self:Round(nDiff * 100,2, false)
		else
			strAmount = self:Round(nAmount)
			strDiff = self:Round(nDiff)
		end
		wndRow:FindChild("InputBox"):SetText(strAmount)
		wndRow:FindChild("DiffBox"):SetText(strDiff)		
	end
	wndList:ArrangeChildrenVert()
end

function SassyMedicSim:StatInputBoxChange( wndHandler, wndControl, strText )
	nInput = tonumber(strText) or 0
	local nSel = wndControl:GetSel().cpCaret
	local tStat = ktStats[wndControl:GetParent():GetData()]
	if tStat.strType == "percentage" then
		nDiff = self:Round(nInput/100 - self:GetPlayerStat(tStat.strStat),4) * 100
		self.tConfig.tStats[tStat.strStat] = nInput/100
	else
		nDiff = self:Round(nInput - self:GetPlayerStat(tStat.strStat))
		self.tConfig.tStats[tStat.strStat] = nInput
	end
	if nDiff < 0 then
		wndControl:GetParent():FindChild("DiffBox"):SetTextColor(CColor.new(1,0,0))
	else
		wndControl:GetParent():FindChild("DiffBox"):SetTextColor(CColor.new(1,1,1))
	end
	if tStat.bReversed then
		nDiff = 0-nDiff
	end
	wndControl:GetParent():FindChild("DiffBox"):SetText(nDiff)
	
	if string.sub(strText,string.len(strText)) == "." then
		nInput = nInput.."."
	elseif string.sub(strText,string.len(strText)-1) == ".0" then
		nInput = nInput..".0"
	elseif nInput == 0 then
		nInput = ""
	end
	wndControl:SetText(nInput)
	wndControl:SetSel(nSel)
end

function SassyMedicSim:UpdateConfigAMPsWindow()
	if not self.tConfig.tAMPs then
		self:SyncAMPs()
	end
	local wndList = self.wndMain:FindChild("AMPsBG"):FindChild("List")
	local nScrollPos = wndList:GetVScrollPos()
	wndList:DestroyChildren()
	for k,strAMP in ipairs(ktConfigAMPs) do
		local wndRow = Apollo.LoadForm(self.xmlDoc,"ConfigAMPRow",wndList,self)
		wndRow:SetData(strAMP)
		wndRow:FindChild("Label"):SetText(self:GetLocalAMPName(strAMP))
		if self.tConfig.tAMPs[strAMP] then
			wndRow:FindChild("ConfigAMPButton"):SetBGColor(ktColors["Cyan"])
		end
	end
	local tConfigRuneSets = {
        "Assassin",
        "Echo Burst",
        "Technophile",
        "Tech Fire Starter",
        "Fusion Blast",
		"Full Charge",
	}
	if not self.tConfig.tRuneSets then
		self:SyncRuneSets()
	end
	for k,strSet in ipairs(tConfigRuneSets) do
		local wndRow = Apollo.LoadForm(self.xmlDoc,"ConfigRuneSetRow",wndList,self)
		wndRow:SetData(strSet)
		wndRow:FindChild("Label"):SetText(strSet)
		wndRow:FindChild("InputBox"):SetText(self.tConfig.tRuneSets[strSet] or 0)
	end
	wndList:ArrangeChildrenVert()
	wndList:SetVScrollPos(nScrollPos)
end

function SassyMedicSim:ConfigAMPClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if wndControl ~= wndHandler then
		return
	end
	local strAMP = wndControl:GetParent():GetData()
	if not strAMP then
		return
	end
	self.tConfig.tAMPs[strAMP] = not self.tConfig.tAMPs[strAMP]
	self:UpdateConfigAMPsWindow()
end

function SassyMedicSim:GetLocalAMPName(strAMP)
	local nAMPId
	for k,v in pairs(tAMPIds) do
		if v == strAMP then
			nAMPId = k
			break
		end
	end
	if not nAMPId then
		return
	end
	for _,tAugment in pairs(AbilityBook.GetEldanAugmentationData(AbilityBook.GetCurrentSpec()).tAugments) do
		if tAugment.nId == nAMPId then
			return tAugment.strTitle
		end
	end
end

function SassyMedicSim:RuneSetInputBoxChange( wndHandler, wndControl, strText )
	nInput = tonumber(strText) or 0
	local nSel = wndControl:GetSel().cpCaret
	local strSet = wndControl:GetParent():GetData()
	self.tConfig.tRuneSets[strSet] = nInput
	if nInput == 0 then
		nInput = ""
	end
	wndControl:SetText(nInput)
	wndControl:SetSel(nSel)
end

function SassyMedicSim:UpdateConfigSpecialsWindow()
	local wndList = self.wndMain:FindChild("SpecialsBG"):FindChild("List")
	local nScrollPos = wndList:GetVScrollPos()
	wndList:DestroyChildren()
	local wndGadget = Apollo.LoadForm(self.xmlDoc,"ConfigGadget",wndList,self)
	self:UpdateConfigGadget(wndGadget)
	local tSpecials = {
		"Impact",
		"Unleash Anger",
		"Rage",
	}
	self.tConfig.tSpecials = self.tConfig.tSpecials or {}
	for k,strSpecial in ipairs(tSpecials) do
		local wndRow = Apollo.LoadForm(self.xmlDoc,"ConfigSpecialRow",wndList,self)
		wndRow:SetData(strSpecial)
		wndRow:FindChild("Label"):SetText(strSpecial)
		self.tConfig.tSpecials[strSpecial] = self.tConfig.tSpecials[strSpecial] or { ["nAmount"] = ktSpecialDefaults[strSpecial] }
		wndRow:FindChild("InputBox"):SetText(self.tConfig.tSpecials[strSpecial].nAmount)
		wndRow:FindChild("ConfigSpecialButton"):SetBGColor(self:ToggleButtonColor(self.tConfig.tSpecials[strSpecial].bActive))
	end
	wndList:ArrangeChildrenVert()
	wndList:SetVScrollPos(nScrollPos)
end

function SassyMedicSim:UpdateConfigGadget(wndGadget)
	if not self.tConfig.tGadget then
		self:SetGadgetToDefaults()
	end
	if not self.tConfig.tGadget.bEnabled then
		wndGadget:FindChild("EnableGadget"):FindChild("ToggleButton"):SetBGColor(ktColors["Dark"])
		wndGadget:FindChild("EnableGadget"):FindChild("Label"):SetText("Gadget (Disabled)")
	else
		wndGadget:FindChild("EnableGadget"):FindChild("ToggleButton"):SetBGColor(ktColors["Cyan"])
		wndGadget:FindChild("EnableGadget"):FindChild("Label"):SetText("Gadget (Enabled)")

	end
	local tGadgetVars = { "nCD", "nDuration", "nAP", "nCritChance", "nCritSev", "nStrikethrough" }
	for _,strVar in pairs(tGadgetVars) do
		wndGadget:FindChild(strVar):FindChild("InputBox"):SetText(self.tConfig.tGadget[strVar])
	end
end

function SassyMedicSim:SetGadgetToDefaults()
	self.tConfig.tGadget = {
		["nCD"] = 60,
		["nDuration"] = 10,
		["nAP"] = 0,
		["nCritChance"] = 0,
		["nCritSev"] = 0,
		["nStrikethrough"] = 0,
	}
end

function SassyMedicSim:SetSpecialsToDefaults()
	self.tConfig.tSpecials = {}
	for k,v in pairs(ktSpecialDefaults) do
		self.tConfig.tSpecials[k] = { ["nAmount"] = v }
	end
end

function SassyMedicSim:GadgetInputBoxChange( wndHandler, wndControl, strText )
	nInput = tonumber(strText) or 0
	local nSel = wndControl:GetSel().cpCaret
	local strVar = wndControl:GetParent():GetName()
	self.tConfig.tGadget[strVar] = nInput
	if nInput == 0 then
		nInput = ""
	end
	wndControl:SetText(nInput)
	wndControl:SetSel(nSel)
end

function SassyMedicSim:EnableGadgetClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if wndControl ~= wndHandler then
		return
	end
	self.tConfig.tGadget.bEnabled = not self.tConfig.tGadget.bEnabled
	self:UpdateConfigGadget(wndControl:GetParent():GetParent())
end

function SassyMedicSim:SpecialInputBoxChange( wndHandler, wndControl, strText )
	local strSpecial = wndControl:GetParent():GetData()
	nInput = tonumber(strText) or 0
	local nSel = wndControl:GetSel().cpCaret
	self.tConfig.tSpecials[strSpecial].nAmount = nInput
	if nInput == 0 then
		nInput = ""
	end
	wndControl:SetText(nInput)
	wndControl:SetSel(nSel)
end

function SassyMedicSim:ConfigSpecialClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if wndControl ~= wndHandler then
		return
	end
	local strSpecial = wndControl:GetParent():GetData()
	self.tConfig.tSpecials[strSpecial].bActive = not self.tConfig.tSpecials[strSpecial].bActive
	self:UpdateConfigSpecialsWindow()
end

function SassyMedicSim:ToggleButtonColor(bToggle)
	if bToggle then
		return ktColors["Cyan"]
	else
		return ktColors["Dark"]
	end
end

function SassyMedicSim:UpdateConfigMiscWindow()
	local wndList = self.wndMain:FindChild("MiscBG"):FindChild("List")
	local nScrollPos = wndList:GetVScrollPos()
	wndList:DestroyChildren()
	local wndMisc = Apollo.LoadForm(self.xmlDoc,"ConfigMisc",wndList,self)
	self.tConfig.nMaxEnergizeActuators = self.tConfig.nMaxEnergizeActuators or 1
	wndMisc:FindChild("MaxEnergizeActuators"):FindChild("InputBox"):SetText(self.tConfig.nMaxEnergizeActuators)
	self.tConfig.nMaxAtomizeActuators = self.tConfig.nMaxAtomizeActuators or 3
	wndMisc:FindChild("MaxAtomizeActuators"):FindChild("InputBox"):SetText(self.tConfig.nMaxAtomizeActuators)
	wndMisc:FindChild("InFluxPrioritise"):FindChild("ToggleButton"):SetBGColor(self:ToggleButtonColor(self.tConfig.bInFluxPrioritise))
	wndMisc:FindChild("CoreDamagePrioritise"):FindChild("ToggleButton"):SetBGColor(self:ToggleButtonColor(self.tConfig.bCoreDamagePrioritise))
	wndMisc:FindChild("SaveForEmpProbes"):FindChild("ToggleButton"):SetBGColor(self:ToggleButtonColor(self.tConfig.bSaveForEmpProbes))
	self.tConfig.nTargets = self.tConfig.nTargets or 1
	wndMisc:FindChild("Targets"):FindChild("InputBox"):SetText(self.tConfig.nTargets)
	self.tConfig.nTargetArmor = self.tConfig.nTargetArmor or 1024
	wndMisc:FindChild("TargetArmor"):FindChild("InputBox"):SetText(self.tConfig.nTargetArmor)	
	self.tConfig.nTargetResist = self.tConfig.nTargetResist or 1024
	wndMisc:FindChild("TargetResist"):FindChild("InputBox"):SetText(self.tConfig.nTargetResist)	
	self.tConfig.nTargetDeflect = self.tConfig.nTargetDeflect or 11
	wndMisc:FindChild("TargetDeflect"):FindChild("InputBox"):SetText(self.tConfig.nTargetDeflect)	
	self.tConfig.nTargetDeflectCrit = self.tConfig.nTargetDeflectCrit or 0
	wndMisc:FindChild("TargetDeflectCrit"):FindChild("InputBox"):SetText(self.tConfig.nTargetDeflectCrit)
	self.tConfig.nSimpleSimTime = self.tConfig.nSimpleSimTime or 600
	wndMisc:FindChild("SimpleSimTime"):FindChild("InputBox"):SetText(self.tConfig.nSimpleSimTime)	
	self.tConfig.nMultiSimTime = self.tConfig.nMultiSimTime or 600
	wndMisc:FindChild("MultiSimTime"):FindChild("InputBox"):SetText(self.tConfig.nMultiSimTime)
	self.tConfig.nMultiSimIterations = self.tConfig.nMultiSimIterations or 2000
	wndMisc:FindChild("MultiSimIterations"):FindChild("InputBox"):SetText(self.tConfig.nMultiSimIterations)
	self.tConfig.nDelay = self.tConfig.nDelay or 0.1
	wndMisc:FindChild("Delay"):FindChild("InputBox"):SetText(self.tConfig.nDelay)

	wndList:SetVScrollPos(nScrollPos)	
end

function SassyMedicSim:SetMiscOptionsToDefaults()
	self.tConfig.nMaxEnergizeActuators = 1
	self.tConfig.nMaxAtomizeActuators = 3
	self.tConfig.bInFluxPrioritise = true
	self.tConfig.bCoreDamagePrioritise = true
	self.tConfig.bSaveForEmpProbes = true
	self.tConfig.nTargets = 1
	self.tConfig.nTargetArmor = 1024
	self.tConfig.nTargetResist = 1024	
	self.tConfig.nTargetDeflect = 11	
	self.tConfig.nTargetDeflectCrit = 0
	self.tConfig.nSimpleSimTime = 600	
	self.tConfig.nMultiSimTime = 600
	self.tConfig.nMultiSimIterations = 2000
	self.tConfig.nDelay = 0.1
end

function SassyMedicSim:SetDefaultConfigBooleans()
	self.tConfig.bInFluxPrioritise = true
	self.tConfig.bCoreDamagePrioritise = true
	self.tConfig.bSaveForEmpProbes = true
end

function SassyMedicSim:MiscInputBoxChange( wndHandler, wndControl, strText )
	local nMin,nMax = 0,1
	local strOption = wndControl:GetParent():GetName()
	if strOption == "MaxEnergizeActuators" then
		nMin,nMax = 0,4
	elseif strOption == "MaxAtomizeActuators" then
		nMin,nMax = 0,4
	elseif strOption == "Targets" then
		nMin,nMax = 1,10
	elseif strOption == "TargetArmor" then
		nMin,nMax = 0,999999
	elseif strOption == "TargetResist" then
		nMin,nMax = 0,999999
	elseif strOption == "TargetDeflect" then
		nMin,nMax = 0,999
	elseif strOption == "TargetDeflectCrit" then
		nMin,nMax = 0,999
	elseif strOption == "SimpleSimTime" then
		nMin,nMax = 1,200000
	elseif strOption == "MultiSimTime" then
		nMin,nMax = 1,200000
	elseif strOption == "MultiSimIterations" then
		nMin,nMax = 1,10000
	elseif strOption == "Delay" then
		nMin,nMax = 0,1
	end
	nInput = tonumber(strText) or nMin
	nInput = math.min(nInput,nMax)
	nInput = math.max(nInput,nMin)
	local nSel = wndControl:GetSel().cpCaret
	self.tConfig["n"..strOption] = nInput
	if string.sub(strText,string.len(strText)) == "." then
		nInput = nInput.."."
	elseif string.sub(strText,string.len(strText)-1) == ".0" then
		nInput = nInput..".0"
	elseif nInput == nMin and strText ~= tostring(nInput) then
		nInput = ""
	end
	wndControl:SetText(nInput)
	wndControl:SetSel(nSel)
	
end

function SassyMedicSim:MiscToggleClick( wndHandler, wndControl, eMouseButton, nLastRelativeMouseX, nLastRelativeMouseY )
	if wndControl ~= wndHandler then
		return
	end
	local strOption = wndControl:GetParent():GetName()
	self.tConfig["b"..strOption] = not self.tConfig["b"..strOption]
	self:UpdateConfigMiscWindow()
end

-----------------------------------------------------------------------------------------------
-- SassyMedicSim Save / Restore
-----------------------------------------------------------------------------------------------
function SassyMedicSim:GetSavedVars()
	return {
		"nSimSpeed",
		"tSpellPriorities",
		"tStats",
		"tSpells",
		"tAMPs",
		"tRuneSets",
		"bIncludeBreakpoints",
		"tGadget",
		"nMaxEnergizeActuators",
		"nMaxAtomizeActuators",
		"bInFluxPrioritise",
		"bCoreDamagePrioritise",
		"bSaveForEmpProbes",
		"nTargets",
		"nTargetArmor",
		"nTargetResist",
		"nTargetDeflect",
		"nTargetDeflectCrit",
		"nSimpleSimTime",
		"nMultiSimTime",
		"nMultiSimIterations",
		"tSpecials",
		"nDelay",
	}
end


function SassyMedicSim:OnSave(eLevel)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then
        return nil
    end
	local tData = {}
	local tSavedVars = self:GetSavedVars()
	if self.bSimSetRunning and self.strSimType ~= "Simple" then
		local tSavedSim = {
			strSimType = self.strSimType,
			nSimulationTime = self.nSimulationTime,
			nMultiSim = self.nMultiSim,
			nMultiSimIterations = self.nMultiSimIterations,
			tMultiSimDamage = self.tMultiSimDamage,
		}
		if self.strSimType == "StatWeight" then
			tSavedSim.tStatWeightSimulations = self.tStatWeightSimulations
			tSavedSim.nCurrentStatWeightSim = self.nCurrentStatWeightSim
		end
		tData.tSavedSim = tSavedSim
	end
	
	if self.tStatWeightSimulations then
		tData.tStatWeightSimulations = self.tStatWeightSimulations
	end
	
	tData.tConfig = {}	
	for _,strVar in pairs(tSavedVars) do
		tData.tConfig[strVar] = self.tConfig[strVar]
	end
	
	return tData
end

function SassyMedicSim:OnRestore(eLevel, tData)
	local tSavedVars = self:GetSavedVars()
	if tData.tSavedSim then
		self.bSavedSim = true
		for k,v in pairs(tData.tSavedSim) do
			self[k] = v
		end
	end
	if tData.tStatWeightSimulations then
		self.tStatWeightSimulations = tData.tStatWeightSimulations
	end
	if tData.tConfig then
		for _,strVar in pairs(tSavedVars) do
			self.tConfig[strVar] = tData.tConfig[strVar]
		end
	end
end

-----------------------------------------------------------------------------------------------
-- SassyMedicSim Instance
-----------------------------------------------------------------------------------------------
local SassyMedicSimInst = SassyMedicSim:new()
SassyMedicSimInst:Init()
